<?php
#G
#=
/****************************************************************************
Copyright 2002, Daniel Deycard, Jacques Messines, Stéphanie Roussel, Jean-Marie Treins
(CATICE Académie de Bordeaux)

This file is part of GiBii/Melia.

GiBii/Melia is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

GiBii/Melia is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GiBii/Melia; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

****************************************************************************/
include("../include/vars_adm.php");
include("../include/util.inc.php");
$statut=$_REQUEST['statut'];
opensession($statut,false);
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
       <title>Fiche d'une classe</title>
<link rel="stylesheet" href="<?php echo "../themes/".$etab_theme."/b2i.css" ?>">
</head>

<?php


switch ($statut) {
       case "Prof":
           echo "<BODY class='arialprof'>";
           break;
       case "Admin":
           echo "<BODY class='arialadmin'>";
           break;
       case "Gest":
           echo "<BODY class='arialgest'>";
           break;
   }

if (!isset($divcod)) exit();
if ($objet!="liste")  {
    $pretitre="Attribution manuelle d'items pour les élèves ";
    $soustitre="Attention, ici il s'agit de donner directement des items aux élèves,
                par exemple pour recopier une feuille de position papier.<br> Utilisez les liens placés sur le nom des élèves.";
}
else {
    $pretitre="Elèves ";
    $soustitre="";
    //En-tête pour impression
    Print "<p class='libelle_admin'>".$etab_nom."&nbsp;&nbsp;&nbsp;&nbsp;".
                 $etab_adresse."&nbsp;&nbsp;&nbsp;&nbsp;".$etab_codepostal.
                 "&nbsp;&nbsp;".$etab_ville;
    Print "<hr>";
}

print "<p class='sous_titre'>";
if ($divgro=='D') $midtit="de la classe "; else $midtit="du groupe ";
print $pretitre.$midtit.$divcod."</p>";
if ($soustitre!="") print "<hr><p class='attention avis5'>$soustitre</p></br>";



$conn  = connecte($host,$user,$mdp,$db);
$sql="SELECT eleves.nom, eleves.prenom, eleves.dnaiss, eleves.eleve_id, comptes.login
        FROM eleves, comptes,lien_eleves_classes
       WHERE eleves.eleve_id=comptes.eleve_id
         and eleves.eleve_id=lien_eleves_classes.eleve_id
         and lien_eleves_classes.classe_id=$classe_id
         and eleves.annee='$sess_ascol'
       ORDER BY nom, prenom;" ;
$resclasse=query($sql);
$nbelev=0;

//début du tableau
print "<div align='center'><table border='1'>\n";
print "<tr class='rubrique'>\n";
print "\t<td width=\"150\">Nom</td><td  width=\"150\">Prénom</td><td>Date de naissance</td><td>Login</td></tr>\n";


while ($rowclasse=mysql_fetch_array($resclasse)) {
      $nbelev++;
      $nom=stripslashes($rowclasse["nom"]);
      $prenom=stripslashes($rowclasse["prenom"]);
      $dnaiss=$rowclasse["dnaiss"];
      $login=stripslashes($rowclasse["login"]);
      $id=$rowclasse["eleve_id"];
//Affichage d'une ligne
     print "\t<tr >\n";
     if ($objet=="liste")
        print "\t<td>&nbsp;&nbsp;$nom</td>\n";
     else
        print "\t<td><a href=\"../outils/saisie_admin.php?eleve_id=$id&classe_id=$classe_id&divcod=$divcod&statut=$statut&divgro=$divgro\" title=\"Saisie manuelle des items de $nom\">&nbsp;&nbsp;$nom</a></td>\n";

     print "\t<td>&nbsp;&nbsp;$prenom</td>\n";
     print "\t<td>&nbsp;&nbsp;$dnaiss</td>\n";
     print "\t<td>&nbsp;&nbsp;$login&nbsp;&nbsp;</td>\n";
     print "\t</tr>\n";
}

 print "</table></div><br>\n";
 print "<p align = 'center'>".$nbelev;
 print ($nbelev>1) ? " élèves" : " élève";
 print "</p>";

?>
</body>
</html>