<?php
#=
/****************************************************************************
Copyright 2002, Daniel Deycard, Jacques Messines, Stéphanie Roussel, Jean-Marie Treins
(CATICE Académie de Bordeaux)

This file is part of GiBii/Melia.

GiBii/Melia is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

GiBii/Melia is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GiBii/Melia; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
****************************************************************************/
include("../include/vars_adm.php");
include("../include/get.inc.php");
include("../include/util.inc.php");
include("../include/utiljs.php");
include("../include/attestations.inc.php");
connexion("$db");
opensession('Admin',false);

function nb_refus($el, $it, $nbjvie, $disc=-1) {
  $nb=0;
 //retourne le nb de refus opposés à la demande de $el pour $it
 $sql_refus="SELECT count(*) as nb_non FROM demandes, reponses ".
    " WHERE demandes.message_id=reponses.message_id ".
    " AND TO_DAYS( CURDATE( ))-TO_DAYS( demandes.quand )<$nbjvie ".
    " AND demandes.disc_id=$disc ".
    " AND eleve_id=$el AND item_id=$it ".
    " AND accord=0;";
 $res=query($sql_refus);
 list($nb)=mysql_fetch_array($res);
  return $nb;
}


function apure_demandes($etab,$nbval,$nbjvie,$nbjvie_old,$nbrefus,$modul) {
 //remet à plat la table des demandes, par ex après un changement de stratégie
 //Tient compte de  $etab_nb_validations, de $etab_nbj_vie_demande
 //et de $etab_nb_max_refus
 global $tablang,$MODULE;

     //récupérer les disciplines une fois pour toutes pour éviter les requêtes (utile partout)
     //ATTENTION, pour Melia il faut commencer à 0 donc :
     if ($MODULE=='Melia') $initial=0;      else $initial=1;
    $res3=query("SELECT libelle,code_langue FROM disciplines ORDER BY disc_id");
    for ($i=$initial; list($tablang[$i],$tabcodelang[$i])=mysql_fetch_array($res3) ; $i++);


 $mess_ret="Modifications apportées aux items en attente de validation :<br>";
 //Préparer les demandes de l'établissement
 $sqldem="SELECT demandes.message_id, TO_DAYS( CURDATE( ))-TO_DAYS( demandes.quand )  AS nbj, demandes.eleve_id, demandes.item_id, demandes.disc_id ".
    " FROM demandes,eleves ".
    " WHERE demandes.eleve_id=eleves.eleve_id ".
    " AND TO_DAYS( CURDATE( ))-TO_DAYS( demandes.quand )<$nbjvie_old ".
    " AND eleves.etab_id=$etab ".
    " ORDER BY quand desc;";
 $res=query($sqldem);
 while (list($mess_id, $nbj, $el_id, $it_id, $disc)=mysql_fetch_array($res)) {

    //Trop de refus et pas acquis on vire !      Trop vieux on vire  !
    $elev=geteleve($el_id,0);
    if  ((bilan($el_id, $it_id, $disc)) && (!itemacquis($el_id,$it_id,$disc))) {
        //Si l'item est acquis et pas dans resultats on l'écrit
        query("INSERT INTO resultats SET item_id=$it_id, eleve_id=$el_id, disc_id=$disc, quand=NOW();");
        //Il faut aussi virer la demande afférente pour qu'elle n'apparaisse plus aux profs ?????
        //query("DELETE FROM demandes WHERE message_id=$mess_id;");
        //Pour Melia on affiche dans quelle langue on a réajusté
        if ($modul=='Melia') $langue="en ".$tablang[$disc];  else $langue='';
        $mess_ret.="<br>Item acquis $it_id pour $elev  $langue";
        //On vériife si ça ne donne pas un brevet ?
        calcule_brevets($el_id);
        }
    elseif (
            (
             ($nbrefus!=0)
               && (nb_refus($el_id, $it_id, $nbjvie, $disc)>=$nbrefus)
               && (!itemacquis($el_id,$it_id,$disc))
            )
            ||  ($nbj >$nbjvie)
           ) {
          //virer la demande et les réponses associées
          query("DELETE FROM demandes WHERE message_id=$mess_id;");
          query("DELETE FROM reponses WHERE message_id=$mess_id;");
          $mess_ret.="<br>Trop de refus ou date dépassée : demande annulée pour l'item $it_id pour $elev";
          }
 } //fin while
 return $mess_ret;
}

function get_nbrep($mid) {
 //retourne le nb de réponses OUI du message $mid
 $n=0;
 $res=query("SELECT count(*) as nbr FROM reponses WHERE accord=1 and message_id=$mid;");
 list($n)=mysql_fetch_array($res);
 return $n;
}


function abonde_reponses($etab, $nbval) {
 //ajoute des réponses oui jusqu'à ce qu'il y en ait $nbval
  $mess_ret="";
 //Rechercher les demandes de l'établissement qui correspondent à un résultat
 $sqlrep="SELECT demandes.message_id, demandes.eleve_id, demandes.item_id ".
    " FROM demandes, eleves, resultats ".
    " WHERE demandes.eleve_id=eleves.eleve_id ".
    " AND eleves.eleve_id=resultats.eleve_id ".
    " AND resultats.item_id=demandes.item_id ".
    " AND eleves.etab_id=$etab;";
 $res=query($sqlrep);
 //Pour chacune d'elles on compte les réponses associées
 while (list($messid,$elid, $itid)=mysql_fetch_array($res)) {
  $nbrep=get_nbrep($messid);
  //Et on ajoute les bonnes réponses
  $cpt=$nbval-$nbrep;
  for ($i=0;$i<$cpt;$i++) {
   query("INSERT INTO reponses SET accord=1, quand=NOW(),
        commentaire='Réponse technique $i', message_id=$messid, prof_id=0;");
      }
  $mess_ret.="<br>$i réponses ajoutées pour l'élève $elid, item $itid";
  }
 return $mess_ret;
}

//$old_max_refus=$tabsession['etab_nb_max_refus'];
//$old_nbj_vie_demande=$tabsession['etab_nbj_vie_demande'];
//$old_nb_validations=$tabsession['etab_nb_validations'];

$source=$_GET['source'];;
if (strpos($source, "?")>0) $source=substr($source,0,strpos($source,"?"));
switch ($source) {
    case "options"   :
         //deuxième passage : traitement du formulaire
         //$style sera celui envoyé par les cas ci-dessous
         //recuprequest() donne priorité aux variables GET et POST sur celles
         //de session. C'est essentiel pour le 2e passage où les variables
         //de session auraient écrasé les variables POST engrangées dans le
         //formulaire (ce qu'a fait opensession).
         recuprequest(); //rétablit la priorité au POST
         break;
    case "admin_bas" :
         $style="arialadmin";
         //premier passage : on mémorise les 2 scripts suivants
         //les 2 points d'interrogation '?' sont normaux ! Il y a 2 niveaux de paramètres
         $cible1="options.php?source=options&cible2=../admin/admin_ut.php&style=".$style."&etab_id=".$etab_id;
         break;
    default: print "Vous n'êtes pas autorisé à accéder directement à cette page.";
             exit(); //entrée anormale
}

if (!isset($cible2)) {  //premier passage : on affiche le formulaire
    include("../admin/options.form.php");
}
else {
    //traitement du formulaire
    //========================
    if (isset($btn_sauver)) {
       $temps_limite=(int) $_POST['temps_limite'];
       //print $temps_limite.'<br />';
       if (empty($temps_limite) || !is_int($temps_limite) || $temps_limite>$SESS_TIMEOUT_MAX)
           $temps_limite=$SESS_TIMEOUT_MAX;
       elseif ($temps_limite<$SESS_TIMEOUT_MIN)
           $temps_limite=$SESS_TIMEOUT_MIN;
       //print $temps_limite.'<br />';
       //Mise à la norme des booléens
       if (isset($alert_message_vide)) $alert_message_vide=@bool($alert_message_vide); else $alert_message_vide=0;
       if (isset($mdp_eleve)) $mdp_eleve=@bool($mdp_eleve);  else  $mdp_eleve=0;
       if (isset($mdp_prof)) $mdp_prof=@bool($mdp_prof);  else $mdp_prof=0;
       if (isset($fiche_profs)) $fiche_profs=@bool($fiche_profs);  else $fiche_profs=0;
       if (isset($stats_profs)) $stats_profs=@bool($stats_profs); else  $stats_profs=0;
       if (isset($pop_profs)) $pop_profs=@bool($pop_profs); else $pop_profs=0;
       if (isset($vouvoyer_elev)) $vouvoyer_elev=@bool($vouvoyer_elev);   else $vouvoyer_elev=0;

       //Garder ce param pour sadmin...
       //$modifs_items_etab=bool($modifs_items_etab);
       if (isset($valid_profs)) $valid_profs=@bool($valid_profs);   else  $valid_profs=0;
       if (isset($result_profs)) $result_profs=@bool($result_profs);  else  $result_profs=0;
       if (isset($groupes_profs)) $groupes_profs=@bool($groupes_profs);  else  $groupes_profs=0;
       if (isset($menus_CSS)) $menus_CSS=@bool($menus_CSS);  else  $menus_CSS=0;

       //quelques addslashes...
       $etab_nom=addslashes($etab_nom);
       $etab_adresse=addslashes($etab_adresse);
       $etab_ville=addslashes($etab_ville);
       $etab_tel_admin=stripslashes($etab_tel_admin);
       $etab_mail_admin=stripslashes($etab_mail_admin);

           //print_r($_POST);
           //print "<br>$temps_limite<br>";
       //sauvegarder des paramètres dans la table _Etablissement
       $sqlsauve="UPDATE etablissements
                  SET nom='$etab_nom',
                  adresse='$etab_adresse', codepostal='$etab_codepostal',
                  ville='$etab_ville', mail_admin='$etab_mail_admin',tel_admin='$etab_tel_admin',
                  theme='$etab_theme', menus_CSS=$menus_CSS,
                  niveau='$etab_niveau', nb_validations=$etab_nb_validations,
                  nbj_vie_demande=$etab_nbj_vie_demande, nb_max_demandes=$etab_nb_max_demandes,
                  nb_max_refus=$etab_nb_max_refus,
                  modele_login_e='$etab_modele_login_e',
                  modele_login_p='$etab_modele_login_p',
                  alert_message_vide=$alert_message_vide,
                  mdp_eleve=$mdp_eleve, mdp_prof=$mdp_prof,
                  fiche_profs=$fiche_profs, stats_profs=$stats_profs,
                  pop_profs=$pop_profs, vouvoyer_elev=$vouvoyer_elev,
                  valid_profs=$valid_profs, result_profs=$result_profs, groupes_profs=$groupes_profs,
                  sess_timeout=$temps_limite
                  WHERE etab_id=$etab_id ;";
       query($sqlsauve);
       //Corriger les demandes en cours en cas de changement de stratégie
       $rapport="<br>";

       // print "old_nb_validations : $old_nb_validations actuel : $etab_nb_validations";
       // print "old_nb_refus : $old_max_refus actuel : $etab_nb_max_refus";


       if (($etab_nb_max_refus!=0 && ($etab_nb_max_refus<$old_max_refus || $old_max_refus==0 )) ||
          ($etab_nbj_vie_demande<$old_nbj_vie_demande) ||
          ($etab_nb_validations<$old_nb_validations))
              $rapport=apure_demandes($etab_id,$etab_nb_validations,$etab_nbj_vie_demande,$old_nbj_vie_demande,$etab_nb_max_refus,$MODULE);
       elseif ($etab_nb_validations>$old_nb_validations) {
              //augmentation des nb de validations, on ajuste les réponses...
              //$rapport=abonde_reponses($etab_id,$etab_nb_validations);
            }

       //effectuer éventuellement les modifications des paramètres en mémoire
       //(utile seulement pour une provenance depuis admin -et non install)
       getparams_etab($etab_id);
       //récupère les variables de session depuis _params et les "sessionnise"


       //on peut envoyer la purée HTML à partir de là
        print "<html><head>\n";
        print "<title>Options de $MODULE</title>\n";
        print "<meta http-equiv=\"content-type\" content=\"text/html; charset=ISO-8859-1\">\n";
        print "<link rel=\"stylesheet\" href=\"../themes/".$etab_theme."/b2i.css\">\n";
        print "</head>";
        print "<body class=\"".$style."\">\n";
        print "<p class=\"sous_titre\">Paramètres généraux de $MODULE</p><hr>\n";
        print "<p align=\"center\">&nbsp;\n";
        print "Les nouveaux param&egrave;tres ont &eacute;t&eacute; sauvegard&eacute;s
              avec succ&egrave;s<br>";
        print $rapport;
        print "</p><form name=\"form1\" method=\"post\" action=\"$cible2\" target=\"_top\">";
        print "<p align=\"center\">";
        print "<input type=\"submit\" class=\"coul\" name=\"envoi\" value=\"Suite\">";
        print "</p></form></body></html>";
    }
    else {
        //il demande de poursuivre sans sauvegarder
        include("../include/utiljs.php");

        if (!strpos($cible2,"?")) $separ="?";
           else $separ="&";
           goto($cible2.$separ."stat=adm".$separ."target = \"_top\"");
    }
} //else traitement du formulaire
?>