# Base GiBii
# Contenu de la table _params_globaux
#

#Les paramtres non modifiables par les options du sadmin ont un tag=-1

#paramtres globaux systme (non modifiables depuis GiBii)
#==========================
INSERT INTO _params_globaux VALUES ('VERSION_GIBII','s','5.0.8','Modifi manuellement',-1);
INSERT INTO _params_globaux VALUES ('DATE_GIBII','s','28/01/07','de mme...',-1);
INSERT INTO _params_globaux VALUES ('DISC_ID_DEFAULT', 'i', '1', 'indice de la discipline par dfaut dans diciplines (anglais)', -1);
INSERT INTO _params_globaux VALUES ('DISCIPLINE_DEFAULT', 's', 'Anglais', 'Libell de la discipline par dfaut', -1);
INSERT INTO _params_globaux VALUES ('DATA', 's', '../data', 'Rpertoire des donnes publiques', -1);
INSERT INTO _params_globaux VALUES ('HIDEDATA', 's', '../prive', 'Rpertoire des donnes prives', -1);
INSERT INTO _params_globaux VALUES ('MODULE', 's', 'GiBii', 'Nom du module', -1);
INSERT INTO _params_globaux VALUES ('PERIODE_PROC_LOCAL','i','1','Processus local (tab) lanc tous les jours (en principe !)', -1);
INSERT INTO _params_globaux VALUES ('PERIODE_PROC_GLOBAL','i','2','Processus global lanc tous les jours (en principe !)', -1);
INSERT INTO _params_globaux VALUES ('LAST_PROC_GLOBAL','s','0','Timestamp du dernier lancement', -1);
INSERT INTO `_params_globaux` VALUES ('VERSION_B2I', 's', '2006', 'Version du rfrentiel (2000 vs 2006)', -1);


#paramtres globaux modifiables par le menu options du sadmin
#==============================
INSERT INTO _params_globaux VALUES ('MOIS_RENTREE','i',9,'pour connatre anne scolaire',0);
INSERT INTO _params_globaux VALUES ('MAIL_ADMIN','s','','Adresse de messagerie du superadministrateur',0);
INSERT INTO _params_globaux VALUES ('MDP_MINI', 'i', '0', 'Longueur minimale du mot de passe', 0);
INSERT INTO _params_globaux VALUES ('AGREMENT_CNIL','i','0','La demande d\'agrment  la CNIL a t obtenue', 0);

#lis  la confidentialit des donnes
#"""""""""""""""""""""""""""""""""""""
INSERT INTO _params_globaux VALUES ('ENTREE_STRICTE', 'i', '0', 'Impose  l\'utilisateur de fournir au login une donne caractrisant son tablissement (aucune aide ne lui est fournie)', 0);
INSERT INTO _params_globaux VALUES ('MDP_INIT_GEP', 'i', '0', 'Le premier mot de passe est une donne personnelle du GEP (sinon, c\'est la date de naissance jj/mm)', 0);
INSERT INTO _params_globaux VALUES ('IMPOSE_CHGT_MDP', 'i', '0', 'Impose  l\'utilisateur un changement de mot de passe  l\'ouverture de la premire session', 0);
INSERT INTO _params_globaux VALUES ('PAS_ITEM_MANUEL_GEST', 'i', '0', 'Le compte gestion ne peut pas attribuer d\'items', 0);
INSERT INTO _params_globaux VALUES ('PAS_ITEM_MANUEL_ADMIN', 'i', '0', 'Le compte admin ne peut pas attribuer d\'items', 0);
INSERT INTO _params_globaux VALUES ('PAS_SAUVE_LOCAL', 'i', '0', 'L\'admin ne peut pas rcuprer une sauvegarde partielle de la base localement', 0);
INSERT INTO _params_globaux VALUES ('PAS_IMPORT_EXPORT', 'i', '0', 'L\'admin ne peut pas utiliser les boutons d\'import-export', 0);


INSERT INTO _params_globaux VALUES ('SIMPLITEM', 'i', '1', 'L\'admin ne peut pas accder  la simplification des items', 0);
INSERT INTO _params_globaux VALUES ('ADM_RESTORE', 'i', '1', 'Les admins peuvent restaurer une sauvegarde antrieure', 0);


#lis au message automatique d'inscription
#""""""""""""""""""""""""""""""""""""""""""""""""""""""
INSERT INTO `_params_globaux` VALUES ('MAIL_FROM', 's', 'Saisir un expditeur', 'Inscription tabs : expditeur', 0);
INSERT INTO `_params_globaux` VALUES ('MAIL_TO', 's', 'Saisir un ou plusieurs destinataires', 'Inscription tabs : Destinataire', 0);
INSERT INTO `_params_globaux` VALUES ('MAIL_CC', 's', ' ', 'Inscription tabs : en copie', 0);
INSERT INTO `_params_globaux` VALUES ('MAIL_SUBJECT', 's', 'Votre GiBii est en ligne...', 'Inscription tabs : objet', 0);

#lis au type d'authentification
#"""""""""""""""""""""""""""""""
INSERT INTO types_auth (nom) VALUES ('Interne');
INSERT INTO types_auth (nom) VALUES ('LDAP');
INSERT INTO types_auth (nom) VALUES ('CAS');


#lis  la scurit
#""""""""""""""""""
INSERT INTO _params_globaux VALUES ('SESS_TIMEOUT_MIN', 'i', '600', 'Valeur infrieure du time-out session impos aux tablissements (entre 2 demandes de page)', 0);
INSERT INTO _params_globaux VALUES ('SESS_TIMEOUT_MAX', 'i', '7200', 'Valeur suprieure du time-out session impos aux tablissements (entre 2 demandes de page)', 0);
