<?php
include("../include/vars_adm.php");
include("../include/util.inc.php");
include ("../include/scriptsql.php");
include ("../include/utiljs.php");
opensession("Sadmin",true);
?>

<html>
<head>
  <title>Changement de référentiel de B2i - Novembre 2006</title>
  <link rel="stylesheet" href="../include/general.css">
</head>
<body class='sadmin' bgcolor='#DBEFED'>

<?php
print "<p class='titre'>Changement du référentiel du B2I - Novembre 2006<hr></p>";
$PHP_SELF=basename($_SERVER['PHP_SELF']);

//=========================================================================================
//On commence par se connecter
//=========================================================================================
connecte($host,$user,$mdp,$db);




//=========================================================================================
//Il ne faut pas faire le changement 2 fois, résultats non garantis !
//=========================================================================================
if (table_dans_base('items_b2i_2000',$db) OR $VERSION_B2I=='2006') {
        print "<span class='warning'><p>Changement déjà effectué !</p></span>";
        print "(Vérifiez la présence des tables *-2000 et la valeur de VERSION_B2I dans les paramètres)";
        exit;
        //Proposer le retour en arrière au lieu de quitter ? A FAIRE si intérêt ????

//Virer pour ceux qui n'ont pas une version 4,7.xxxxx  !!!
        }
        
//=========================================================================================
//Pas de conversion pour une version antérieure à la 4.7.xxx ni pour Melia ou GiCii !
//=========================================================================================

if ($MODULE!='GiBii') {
        print "<span class='warning'>La conversion des items du B2i ne concerne QUE GiBii !</span>";
        exit;	
}

if ((substr($VERSION_GIBII,0,3)!='4.7') OR (!isset($VERSION_B2I))) {
        print "<span class='warning'>Vous n'avez pas fait votre MAJ de scripts d'une version 4.7.x en Sadmin !
                <br />Faites-le et revenez ici ensuite, la conversion ne se fera pas avant...</span>";
        exit;
}        
        

if (!isset($_POST['btn_ok'])) {
//Quelques phrases d'aide
?>
<P class='rubrique'>Veuillez lire attentivement les points suivants (lisez tout !) :</P>
<p  class='centre'>
<table border='1' width=80%><tr><td bgcolor='#FFFFFF'><br>
<OL>
<LI>Interdisez l'accès au site pour cette opération de conversion</LI>
<LI>Sauvegardez votre site complet avant de lancer la conversion</LI>
<UL>
<LI>soit par dump de la base mysql&nbsp;&nbsp;(vous si vous y avez accès, un administrateur sinon)</LI>
<LI>soit par la sauvegarde du sadmin</LI>
<LI>... et recopie des scripts</LI>
</UL>
La conversion du référentiel sauvera en plus individuellement les tables touchées <i>("items","rubriques","libelles","demandes","resultats", "reponses", "lpi")</i></LI>
<LI>Vous avez le choix entre 3 niveaux de conversion expliqués ci-dessous : </LI></OL>
</td></tr></table>
<P>
<p><b><font size='+2'>La conversion mécanique des items</font></b> remplace simplement les items obtenus par leur équivalent du nouveau référentiel lorsqu'il existe, en utilisant une table de conversion située en <i>data/tab_conversion_items.php</i>
<br><font color='blue'>Cette table peut être modifiée au niveau des sites académiques, par les instances TICE locales...
<b>Si tel est votre choix, ne lancez pas la conversion maintenant, modifiez ce tableau d'abord !</b></font>
<br /><br />Pour chaque item :
<ul><li> S'il correspond à plusieurs nouveaux items, il y aura création de nouveaux résultats et/ou de nouvelles demandes.
<li>Si un item correspond à une compétence non reprise, l'enregistrement correspondant sera supprimé.
</ul>
 <b><font size='+2'>La conversion avec respect des 'compétences' acquises au collège</font></b> <i>(idée originale de l'académie d'Aix-Marseille, merci à eux !)</i> ajoute une fonctionnalité à la simple conversion des items ci-dessus (et de ce fait, désavantage un peu moins les élèves bien avancés dans leurs validations en juin 2006) :
<ul><li>Si un élève possède <b>TOUS</b> les items d'une compétence dans les anciennes rubriques 8, 9, 10 il lui sera attribué également toutes les compétences des domaines correspondants dans le nouveau référentiel
<br><i>ancien 8 => 8- Créer, produire, traiter
<br>ancien 9 => 9- Sinformer, se documenter
<br>ancien 10 => 6- Sapproprier un environnement informatique</i>
<li>Même chose appliquée <b>en plus</b> au domaine 5 (en choisissant la dernière option)
<br><i>Ancien 11 => 10- Communiquer, échanger
</i>
<li>L'ancienne rubrique "Culture informatique" n'est pas reprise
<li>La nouvelle rubrique "Adopter une attitude responsable..." contient des items de comportement plus que de compétences et ne sera pas concernée par cette option.
</ul>
Dans les trois cas de figure, notez bien que ça ne remet aucunement en cause les attestations par niveau attribuées <b>avant</b> la conversion.
Les "brevets" obtenus sont stockés et éditables ensuite, même si les nouvelles compétences requises ne sont pas validées.
</p>
<span class='warning'>ATTENTION : pensez à faire passer l'information suivante à tous les validateurs :
<br /><i>Les liens profs-items (compétences prises en charge par chaque prof) ont été également convertis, il faudra que chaque enseignant les vérife dans sa fiche perso.. </i></span><br />
<hr><p class='titre'><b>PATIENCE PENDANT LE TRAITEMENT, IL PEUT ETRE ASSEZ LONG...</b></p><hr>

Votre choix ?
<p  class='centre'>
<table border='1' width=80%  bgcolor='#FFFFFF'><tr><td>
<form name="marseille" action="<?php echo $PHP_SELF; ?>" method="post">
  <input name="pmg" type="radio" value="0" checked>&nbsp;&nbsp;Uniquement conversion mécanique par items
  <br><input name="pmg" type="radio" value="1">&nbsp;&nbsp;Conversion mécanique par items puis respect des 3 premières rubriques de compétences au niveau collège (rubriques 8, 9 et 10)
  <br><input name="pmg" type="radio" value="2">&nbsp;&nbsp;Conversion mécanique par items puis respect des 4 rubriques de compétences au niveau collège (rubriques 8, 9, 10 et 11) 
</td></tr></table></p>
<p align='center'>&nbsp;&nbsp;<i>Vous êtes bien sûr de faire la conversion maintenant ? Alors GOoo... ! &nbsp;&nbsp;&nbsp;&nbsp;==>  &nbsp;&nbsp;  &nbsp;&nbsp;</i>
<input type="submit" name='btn_ok' value="Lancer la conversion des items">

  </p>
</form>

</P>




<?php
//Choix stratégie, proposer l'option Marseille



}
//======================================================================
//AU TRAVAIL !!!!!
//======================================================================

else {
//Là on fait vraiment le boulot !
$pmg=@$_POST['pmg'];
set_time_limit(0);

function arrondir($nombre,$n)
{
return trim(number_format($nombre,$n,".",""));
} 

function newcol($table, $op) {
  //Ajoute ou supprime (si $op=0) une colonne en fin de table pour y stocker l'état
  if ($op==0) $res=query("ALTER TABLE $table DROP `traite` ");
  else $res=query("ALTER TABLE $table ADD `traite` INT DEFAULT '0' NOT NULL");
}

function SQLupdate($table,$old,$new)   {
  //remplace dans toute la table l'item_id et 'traite' à 1
  //On note dans le champ 'traite' qu'on a fait cette étape
  $res=query("UPDATE $table SET item_id=$new, traite=1 WHERE item_id=$old");
  
  //print "<br>Remplacement dans $table de $old par $new";
}


function SQLajoutedem($table,$prec_itid,$new_itid, $prefixe, $compt) {
  //Ajoute une demande identique, sauf l'item_id qui devient $newitid et le commentaire qui se péfixe
  //ATTENTION, on ajoute dans la table $table."_tmp"
  $cible=$table."_tmp";
  $prefixe="[".$prefixe.$compt."] ";
  $res=query("INSERT IGNORE INTO $cible  SELECT NULL,NOW(), CONCAT('$prefixe',commentaire), eleve_id,$new_itid, disc_id, $compt FROM $table WHERE item_id=$prec_itid AND traite=1");
  print "<br> >>  Ajout demande technique pour item $new_itid (clonée depuis $prec_itid)";
}


function SQLajouteres($table,$prec_itid,$new_itid, $compt) {
  //Ajoute un resultat identique, sauf l'item_id qui devient $newitid et le commentaire qui se péfixe
  //ATTENTION, on ajoute dans la table $table."_tmp"
  $cible=$table."_tmp";
  $res=query("REPLACE INTO $cible  SELECT NULL,quand, eleve_id,$new_itid, disc_id,$compt FROM $table WHERE item_id=$prec_itid AND traite=1");
  print "<br> >>  Ajout résultat technique pour item $new_itid (cloné depuis $prec_itid)";
}

function SQLajoutelpi($table,$prec_itid,$new_itid, $compt) {
  //Ajoute un resultat identique, sauf l'item_id qui devient $newitid 
  //ATTENTION, on ajoute dans la table $table."_tmp"
  $cible=$table."_tmp";
  $res=query("REPLACE INTO $cible  SELECT prof_id,$new_itid,$compt FROM $table WHERE item_id=$prec_itid AND traite=1");
  print "<br> >>  Ajout résultat technique pour item $new_itid (cloné depuis $prec_itid)";
}



function SQLsauvetable($anc, $nouv, $dump=1) {

//Crée table-2000 [et sauve l'ancienne dedans si $dump=1]
$tab_cree=array(
  "items"=>"CREATE TABLE $nouv (item_id INTEGER NOT NULL AUTO_INCREMENT,
    brevet_no INTEGER,rub_no INTEGER NOT NULL,s_rub_no INTEGER,
    obligatoire TINYINT NOT NULL DEFAULT 1,CONSTRAINT PK_items PRIMARY KEY (item_id),
    KEY ix_br(brevet_no, rub_no))",

  "rubriques"=>"CREATE TABLE $nouv (rub_no INTEGER NOT NULL,
    libelle TEXT,rub_simple VARCHAR(30),CONSTRAINT PK_rubriques PRIMARY KEY (rub_no))",

  "libelles"=>"CREATE TABLE $nouv (item_id INTEGER NOT NULL,inst TEXT NOT NULL,
    base TEXT NOT NULL,CONSTRAINT PK_libelles PRIMARY KEY (item_id))",

  "demandes"=>"CREATE TABLE $nouv (message_id INTEGER NOT NULL AUTO_INCREMENT,
    quand DATETIME NOT NULL,commentaire TEXT,eleve_id INTEGER NOT NULL,
    item_id INTEGER NOT NULL,disc_id INTEGER,CONSTRAINT PK_demandes PRIMARY KEY (message_id),
    KEY ix_elv_dis(eleve_id, disc_id))",

  "resultats"=>"CREATE TABLE $nouv (resultat_id INTEGER NOT NULL AUTO_INCREMENT,
    quand DATETIME NOT NULL,eleve_id INTEGER NOT NULL,
    item_id INTEGER NOT NULL,disc_id INTEGER DEFAULT 0,
    CONSTRAINT PK_resultats PRIMARY KEY (resultat_id),
    KEY ix_elitdi(disc_id, eleve_id, item_id))",

  "reponses"=>"CREATE TABLE $nouv (reponse_id INTEGER NOT NULL AUTO_INCREMENT,
    accord BOOL NOT NULL DEFAULT 0,quand DATETIME,commentaire TEXT,
    message_id INTEGER,prof_id INTEGER NOT NULL,
    CONSTRAINT PK_reponses PRIMARY KEY (reponse_id),
    KEY ix_elv(message_id),KEY ix_prf(prof_id))",
    
  "lpi"=>"CREATE TABLE $nouv (prof_id INTEGER, item_id INTEGER,
    KEY IDX_lpi1(prof_id),KEY IDX_lpi2(item_id))"
    );


$sqlcree=$tab_cree[$anc];
$rescree=query($sqlcree);
//Vidange
if ($dump==1) $resdump=query("INSERT INTO ".$nouv." SELECT * FROM ".$anc);


}

//=========================================================================================
//                               P R O G   P R I N C I P A L
//=========================================================================================



//=========================================================================================
//Sauvegarde des tables qui seront traitées ensuite (permet de faire marche arrière)=======
//=========================================================================================
print "<p class='rubrique'>Sauvegarde des tables qui seront traitées ensuite : </p>";
$tab_sauve=array("items","rubriques","libelles","demandes","resultats", "reponses", "lpi");
foreach ($tab_sauve as $ts) {
        $ts_sauve=$ts."_b2i_2000";
        print "<br>".$ts." => ".$ts_sauve;
        SQLsauvetable($ts,$ts_sauve);
        }
//Creation de tables temporaires pour l'ajout d'items (sans remplissage)
$tab_sauve=array("demandes","resultats", "lpi");
foreach ($tab_sauve as $ts) {
        $ts_sauve=$ts."_tmp";
        print "<br>".$ts." => ".$ts_sauve;
        SQLsauvetable($ts,$ts_sauve, 0);
        }


print "<hr>";
print "<hr><hr><a name='sauve'></a>";
goto($PHP_SELF."#sauve");
superflush();


if ($pmg>0) {
//=========================================================================================
// Option pour Marseille, on met de côté les domaines acquis dans une table temporaire qui peut durer !
//=========================================================================================
print "<p class='rubrique'>Stockage des anciens domaines de compétences entièrement validés (Marseille) : </p>";
//Table de stockage des triplets élève, rubrique, nbitems
query("DROP TABLE IF EXISTS rubpleines");
$rescree=query("CREATE TABLE `rubpleines` (`eleve_id` INT NOT NULL ,`rub_no` INT NOT NULL ,`nbit` INT NOT NULL )");

//Stockage Organiser des informations...
$restab=query("INSERT INTO rubpleines SELECT resultats.eleve_id, 6, count(items.item_id) as nbit
                FROM items, resultats, eleves
                WHERE rub_no=10
                AND resultats.eleve_id=eleves.eleve_id
                AND items.item_id=resultats.item_id
                AND (annee='2006' OR annee='2005')
                GROUP BY eleves.eleve_id,rub_no
                HAVING nbit=3");
print "Organiser des informations...";
superflush();

//Stockage Créer, produire, traiter
$resprod=query("INSERT INTO rubpleines SELECT resultats.eleve_id, 8, count(items.item_id) as nbit
                FROM items, resultats, eleves
                WHERE rub_no=8
                AND resultats.eleve_id=eleves.eleve_id
                AND items.item_id=resultats.item_id
                AND (annee='2006' OR annee='2005')
                GROUP BY eleves.eleve_id,rub_no
                HAVING nbit=3");
print "<br>Créer, produire, traiter...";
superflush();

//Stockage S\informer, se documenter
$resprod=query("INSERT INTO rubpleines SELECT resultats.eleve_id, 9, count(items.item_id) as nbit
                FROM items, resultats, eleves
                WHERE rub_no=9
                AND resultats.eleve_id=eleves.eleve_id
                AND items.item_id=resultats.item_id
                AND (annee='2006' OR annee='2005')
                GROUP BY eleves.eleve_id,rub_no
                HAVING nbit=3");
print "<br>S'informer et se documenter...";
superflush();

if ($pmg==2) {     //Cas marseille, on restitue aussi les compétences "communiquer-echanger"
//Stockage Communiquer, échanger
$resprod=query("INSERT INTO rubpleines SELECT resultats.eleve_id, 10, count(items.item_id) as nbit
                FROM items, resultats, eleves
                WHERE rub_no=11
                AND resultats.eleve_id=eleves.eleve_id
                AND items.item_id=resultats.item_id
                AND (annee='2006' OR annee='2005')
                GROUP BY eleves.eleve_id,rub_no
                HAVING nbit=1");
print "<br>Communiquer au moyen...";
}

//Après la conversion il faudra réfléchir à quoi en faire ;-))
print "<hr>";
print "<hr><hr><a name='marseille1'></a>";
goto($PHP_SELF."#marseille1");
superflush();
}        //Fin préparation pour stratégie de Marseille

//=========================================================================================
//Vidange des tables sauvées ET de celles qui n'ont plus de sens  =========================
//=========================================================================================
print "<p class='rubrique'>Vidage des tables sauvées ET de celles qui n'ont plus de sens : <p>";
$tab_vide=array("items","rubriques","libelles","libelles_perso", "reponses");
foreach ($tab_vide as $tv) {
        print "<br>".$tv.", ";
        $resvide=query("TRUNCATE $tv");
        }
print "</p><hr>";
print "<hr><hr><a name='vid'></a>";
goto($PHP_SELF."#vid");
superflush();

//=========================================================================================
//Remplir les tables avec nouveaux items  =================================================
//=========================================================================================
print "<p class='rubrique'>Remplissage des tables avec les nouveaux items, libellés, rubriques</p>";
$fichiersSQL =array('04_items_b2i_2006.sql'       => 'items, libelles et rubriques');
$cheminsrv="../data/";
$errexiste=false;
foreach ($fichiersSQL as $nomf=>$comment) {
    $erreur=array();
    $cr=SQL_execfile($cheminsrv.$nomf,$erreurs);
    if (!$cr) $errexiste=true;
    //print "Après $nomf, cr=$cr, ".var_dump($cr)." errexiste=$errexiste<br>";
    if ($cr) {
       print "<i>&nbsp;&nbsp;Fichier <strong>$nomf</strong> : tables $comment remplies correctement</i><br>";
    }
    else {
       print "<p><font color='red'>Erreur dans le fichier <strong>$nomf</strong></font><br />";
       SQL_afferreurs($erreurs);
       print "</p>";
       break;
    }
}
print "<hr>";
print "<hr><hr><a name='new'></a>";
goto($PHP_SELF."#new");
superflush();


//=========================================================================================
//TRAITEMENT des tables demandes reponses et resultats
//=========================================================================================
print "<p class='rubrique'>Traitement des tables demandes, reponses et resultats</p>";
include("tab_conversion_items.php");         //Tableau $item_new
//Pour ne pas se mordre la queue, tous les item_id écrits seront concaténés avec 2 zéros derrière.
$suffixe="00";


//DEBUG
set_time_limit(0);
$w1=getmicrotime();


//=========================================================================================
//On commence par les demandes   ==========================================================
//=========================================================================================
$table='demandes';
print "<br><b>Traitement de la table $table </b><br>";
superflush();

newcol($table,1); //ajout colonne provisoire
$ttmp=$table."_tmp";
newcol($ttmp,1); //ajout colonne provisoire  table tmp

foreach ($item_new as $oldid=>$tnewid) {
   $compteur=0;
   foreach ($tnewid as $newit) {
     $compteur++;
     if ($newit!='0') $newit.=$suffixe;
     if ($compteur==1) {
             SQLupdate($table,$oldid,$newit);
             //print "<br>SQLupdate($table,$oldid,$newit)";
             $base_it=$newit;
     }
     

     //Ajout demandes techniques dans table demandes_tmp
     //En s'appuyant sur l'item déjà modifié au passage 1  (base_it)
     else SQLajoutedem($table, $base_it, $newit, "bonus_",$compteur);
          //Et si plusieurs $oldit ont la même image $newit ?
          //A REFLECHIR : en fait pas grave du tout :
          //Cela va provoquer des doublons qui seront supprimés un peu plus bas...
   }
}

//=========================================================================================
//Traitement de la table reponses  ========================================================
//=========================================================================================
$table='reponses';
print "<br><b>Traitement de la table $table </b><br>";
superflush();

//La table reponses a été vidée, il faut la remplir avec uniquement celles qui ont une demande item_id différent de 0 !
//$resrep0=query("DELETE reponses FROM reponses, demandes WHERE reponses.message_id=demandes.message_id
//        AND demandes.item_id=0");
  
$resrep0=query("INSERT INTO reponses SELECT NULL, r2.accord,r2.quand,r2.commentaire,r2.message_id,r2.prof_id
		FROM reponses_b2i_2000 as r2, demandes 
		WHERE r2.message_id=demandes.message_id AND demandes.item_id!=0");
		      
       
        
        
        
//Ajout des reponses techniques ?
//Je crois que le pb n'est n'est pas un !
//C'est déplacé de faire des réponses techniques à des demandes techniques !
//Ou irait-on ? "un robot répond à un robot"..
//DOnc si une demande qui a déjà une réponse est éclatée en 2 demandes, seule la première aura sa réponse..


//Nettoyage items à 0
$res_nul=query("DELETE FROM demandes WHERE item_id=0");
print "<br><br>Effacement des enregistrements inutiles : ".mysql_affected_rows();


//Récupération des demandes techniques mises de côté
$res_bonus=query("INSERT IGNORE INTO demandes SELECT NULL, quand, commentaire, eleve_id, item_id, disc_id, traite FROM demandes_tmp");
print "<br><br>Demandes techniques ajoutées : ".mysql_affected_rows();

//Division par 100
$res_cent=query("UPDATE demandes SET item_id=item_id/100");
print "<br>Division par 100 des item_id<br>";
superflush();
newcol('demandes',0);        //On vire la colonne provisoire de demandes

//Optimiser
$res_optimise=query("OPTIMIZE TABLE demandes") ;

//DEBUG
$w2=getmicrotime();
$dureebig=$w2-$w1;
print "<font  color='blue'>";
print "<br><br>Traitement demandes en : ".arrondir($dureebig,2)." secondes !</font><br><br>";


//=========================================================================================
//On continue par les résultats                   =========================================
//=========================================================================================

$table='resultats';
print "<br><br><b>Traitement de la table $table </b>";
superflush();

newcol($table,1); //ajout colonne provisoire
$ttmp=$table."_tmp";
newcol($ttmp,1); //ajout colonne provisoire  table tmp

//Supprimer index unique pour pouvoir convertir
$res_suppindex=query("ALTER TABLE `resultats` DROP INDEX `ix_elitdi`");


foreach ($item_new as $oldid=>$tnewid) {
   $compteur=0;
   foreach ($tnewid as $newit) {
            $compteur++;
     if ($newit!=0) $newit.=$suffixe;
     if ($compteur==1) {
     		//Convertion old => new dans table resultats
             SQLupdate($table,$oldid,$newit);
             $base_it=$newit;
     }
     //Ajout resultats techniques dans table resultats_tmp
     //En s'appuyant sur l'item déjà modifié au passage 1  (base_it)
     else SQLajouteres($table,$base_it, $newit,$compteur);
   }
}

//Nettoyage items à 0
$res_nul=query("DELETE FROM $table WHERE item_id=0");
print "<br><br>Effacement des enregistrements inutiles : ".mysql_affected_rows();

//Récupération des résultats techniques mis de côté
$res_bonus=query("INSERT IGNORE INTO resultats SELECT NULL, quand, eleve_id, item_id, disc_id,traite  FROM resultats_tmp");
print "<br><br>Résultats techniques ajoutés : ".mysql_affected_rows();

//On vire la colonne provisoire
newcol($table,0);

//Division par 100
$res_cent=query("UPDATE $table SET item_id=item_id/100");
print "<br>Division par 100 des item_id";

//DEBUG
$w3=getmicrotime();
$dureebig=$w3-$w2;
print "<font  color='blue'>";
print "<br><br>Traitement resultats en : ".arrondir($dureebig,2)." secondes !<br></font>";

//Il faut dédoublonner la table sur eleve_id, item_id, disc_id (garder la dernière)
//Utilisation d'une table temporaire result

print "<br><br><b>Dédoublonnage de la table resultats :</b><br>";
superflush();

$resres=query("DROP TABLE IF EXISTS `result`");
$resres2=query("CREATE TABLE `result` (`quand` datetime NOT NULL default '0000-00-00 00:00:00',
          `eleve_id` int(11) NOT NULL default '0', `item_id` int(11) NOT NULL default '0',
          `disc_id` int(11) NOT NULL default '0', PRIMARY KEY  (`disc_id`,`eleve_id`,`item_id`))");

//Envoi des résultats sans doublon remise en place index
$resddou=query("REPLACE INTO result SELECT quand, eleve_id, item_id, disc_id
        FROM resultats ORDER BY quand");
$resindex=query("ALTER TABLE `result` DROP PRIMARY KEY, ADD UNIQUE  (`eleve_id`,`item_id`,`disc_id`)");
$resprim=query("ALTER TABLE `result` ADD `resultat_id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY FIRST");


$resvide=query("TRUNCATE resultats");
$res_addindex=query("ALTER TABLE `resultats` ADD UNIQUE `ix_elitdi` ( `eleve_id` , `item_id` , `disc_id` )");


//On verse result dans resultats : 2 tables identiques !
$res_flush=query("INSERT INTO resultats SELECT null, quand, eleve_id, item_id, disc_id
                FROM result ORDER BY quand");

//Optimiser
$res_optimise=query("OPTIMIZE TABLE $table") ;


//On peut virer les tables temporaires demandes_tmp  et resultats_tmp
//
query("DROP TABLE resultats_tmp");
query("DROP TABLE demandes_tmp");


//DEBUG
$w4=getmicrotime();
$dureebig=$w4-$w3;
print "<font  color='blue'>";
print "<br><br>Dédoublonnage resultats en : ".arrondir($dureebig,2)." secondes !<br></font>";
print "<hr>";
print "<hr><hr><a name='doub'></a>";
goto($PHP_SELF."#doub");

//=========================================================================================
//On termine la série des tables par les compétences profs (lpi) ==========================
//=========================================================================================

$table='lpi';
print "<br><br><b>Traitement de la table $table </b>";
superflush();

newcol($table,1); //ajout colonne provisoire
$ttmp=$table."_tmp";
newcol($ttmp,1); //ajout colonne provisoire  table tmp

//Echange ou ajout items
foreach ($item_new as $oldid=>$tnewid) {
   $compteur=0;
   foreach ($tnewid as $newit) {
            $compteur++;
     if ($newit!=0) $newit.=$suffixe;
     if ($compteur==1) {
             SQLupdate($table,$oldid,$newit);
             $base_it=$newit;
     }
     //Ajout demandes techniques dans table lpi_tmp
     //En s'appuyant sur l'item déjà modifié au passage 1  (base_it)
     else SQLajoutelpi($table, $base_it, $newit,$compteur);
          //Et si plusieurs $oldit ont la même image $newit ?
          //A REFLECHIR : en fait pas grave du tout :
          //Cala va provoquer des doublons qui seront supprimés un peu plus bas...
   }
   }
//Nettoyage items à 0
$res_nul=query("DELETE FROM $table WHERE item_id=0");
print "<br><br>Effacement des enregistrements inutiles : ".mysql_affected_rows();

//Récupération des résultats techniques mis de côté
$res_bonus=query("INSERT INTO lpi SELECT * FROM lpi_tmp");
print "<br><br>Résultats techniques ajoutés : ".mysql_affected_rows();

//On vire la colonne provisoire
newcol($table,0);
newcol($ttmp,0);

//Division par 100
$res_cent=query("UPDATE $table SET item_id=item_id/100");
print "<br>Division par 100 des item_id";

//Dédoublonnage ?
//Pour dédoublonner, on vide lpi_tmp, on lui met un index sur les 2 colonnes et on fait de l'INSERT IGNORE
$resvide=query("TRUNCATE lpi_tmp");
$res_addindex=query("ALTER TABLE `lpi_tmp` ADD UNIQUE `ix_prit` ( `prof_id` , `item_id` )");
$res_flush=query("INSERT IGNORE INTO lpi_tmp SELECT * FROM lpi");

//La bonne table est lpi_tmp, on la verse dans l'autre
$resvide=query("TRUNCATE lpi");
//On verse result dans resultats : 2 tables identiques !
$res_flush=query("INSERT INTO lpi SELECT * FROM lpi_tmp");

query("DROP TABLE lpi_tmp");
//DEBUG
$w5=getmicrotime();
$dureebig=$w5-$w4;
print "<font  color='blue'>";
print "<br><br>Traitement table lien profs-items en : ".arrondir($dureebig,2)." secondes !<br></font>";
print "<hr>";

//=========================================================================================
//Dans le cas du transfert de rubriques pleines, il faut les compléter dans le nouveau référentiel...
//Choix non obligatoire proposé en début de conversion
//=========================================================================================

if ($pmg>0) { //Rajouter les items qui manquent aux élèves qui avaient des domaines complets
print "<p class='rubrique'>Conversion avec transfert des compétences : ajout des nouveaux resultats</p>";

superflush();


//On va compléter resultats en se servant de result qui est son clone

//Domaine 6- Sapproprier un environnement informatique
$res6=query("INSERT INTO resultats SELECT NULL, NOW(),rubpleines.eleve_id, items.item_id, -1
                FROM (items  INNER JOIN rubpleines ON items.rub_no=rubpleines.rub_no )
                LEFT JOIN result
                ON rubpleines.eleve_id=result.eleve_id
                AND items.item_id=result.item_id
                WHERE result.item_id IS NULL
                AND rubpleines.rub_no=6");
print "<br>Domaine 6- Sapproprier un environnement informatique &nbsp;&nbsp; >> ".mysql_affected_rows()." résultats ajoutés";


//Domaine 8- Créer, produire, traiter
$res8=query("INSERT INTO resultats SELECT NULL, NOW(),rubpleines.eleve_id, items.item_id, -1
                FROM (items  INNER JOIN rubpleines ON items.rub_no=rubpleines.rub_no )
                LEFT JOIN result
                ON rubpleines.eleve_id=result.eleve_id
                AND items.item_id=result.item_id
                WHERE result.item_id IS NULL
                AND rubpleines.rub_no=8");
print "<br>Domaine 8- Créer, produire, traiter &nbsp;&nbsp; >> ".mysql_affected_rows()." résultats ajoutés";

//Domaine 9- Sinformer, se documenter
$res9=query("INSERT INTO resultats SELECT NULL, NOW(),rubpleines.eleve_id, items.item_id, -1
                FROM (items  INNER JOIN rubpleines ON items.rub_no=rubpleines.rub_no )
                LEFT JOIN result
                ON rubpleines.eleve_id=result.eleve_id
                AND items.item_id=result.item_id
                WHERE result.item_id IS NULL
                AND rubpleines.rub_no=9");
print "<br>Domaine 9- Sinformer, se documenter &nbsp;&nbsp;  >> ".mysql_affected_rows()." résultats ajoutés";

if ($pmg==2) {   //dernier cas : restitution des compétences de "Communiquer Echanger"
//Domaine 10- Communiquer, échanger : 
$res10=query("INSERT INTO resultats SELECT NULL, NOW(),rubpleines.eleve_id, items.item_id, -1
                FROM (items  INNER JOIN rubpleines ON items.rub_no=rubpleines.rub_no )
                LEFT JOIN result
                ON rubpleines.eleve_id=result.eleve_id
                AND items.item_id=result.item_id
                WHERE result.item_id IS NULL
                AND rubpleines.rub_no=10");
print "<br>Domaine 10- Communiquer, échanger &nbsp;&nbsp; >> ".mysql_affected_rows()." résultats ajoutés";
}

$res_fin=query("DROP TABLE `rubpleines` ");
} //Fin de la stratégie de Marseille...
print "<hr>";

//========================================================================================================

print "<br><p class='sous_titre'>CONVERSION TERMINEE !</p><br>";

//Plus besoin de result et consort !
$res_fin=query("DROP TABLE `result` ");


//On incrémente la version du référentiel ET de Gibii
$res_version1=query("UPDATE `_params_globaux` SET  param_val='2006' WHERE param_nom='VERSION_B2I' ");
$res_version2=query("UPDATE `_params_globaux` SET  param_val='5.0.6' WHERE param_nom='VERSION_GIBII' ");
$res_version3=query("UPDATE `_params_globaux` SET  param_val='09/01/2006' WHERE param_nom='DATE_GIBII' ");

//DEBUG
$w6=getmicrotime();
$dureebig=$w6-$w1;
print "<font  color='blue'>";
print "<br><br>Total des traitements en : ".arrondir($dureebig,2)." secondes !<br></font>";
print "<hr><hr><a name='fin'></a>";
goto($PHP_SELF."#fin");
} //Fin traitement général



//=========================================================================================
//            FIN
//=========================================================================================

?>

</body>
</html>