<?php
#=
/****************************************************************************
Copyright 2002-2004, Daniel Deycard, Jacques Messines, Alain Pomirol
(CATICE Académie de Bordeaux)

This file is part of GiBii/Melia.
GiBii/Melia is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

GiBii/Melia is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GiBii/Melia; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

****************************************************************************/

//fonctions utiles pour l'étude d'un élève (dans /eleve et dans /gestion)
function demandeactive($eleve_id,$item_id,$disc_id=-1) {
global $etab_nbj_vie_demande;
// retourne 0 ou un message_id
if ($disc_id==-1) $et=''; else $et="and  disc_id=$disc_id";
$sqldem="SELECT message_id FROM demandes
         WHERE  eleve_id=$eleve_id
           and  item_id=$item_id
           $et ".
           //and  TO_DAYS(CURDATE())-TO_DAYS(quand)<=".$etab_nbj_vie_demande." ".
           "ORDER BY quand DESC";
$resdem=query($sqldem);
if (mysql_num_rows($resdem)) {
    $rowdem=mysql_fetch_array($resdem);
    return $rowdem["message_id"];
}
else return 0;
}

function demandes_en_attente($eleve_id,$disc=-1) {
global $etab_nbj_vie_demande;
if ($disc==-1) $req_disc=""; else $req_disc=" and  disc_id=$disc ";
$resdem=query("SELECT message_id,item_id FROM demandes
                WHERE  eleve_id=$eleve_id ".$req_disc.
                //"  and  TO_DAYS(CURDATE())-TO_DAYS(quand)<=$etab_nbj_vie_demande
                " ORDER BY quand DESC");
$liste=array();
while (list($message_id,$item_id)=mysql_fetch_array($resdem)) {
    if (!itemacquis($eleve_id,$item_id)) $liste[]=$item_id;
}
return $liste;
}


function bilanrep($message_id) {
$sqlbil ="SELECT accord , COUNT(accord) as nbrep ".
      "FROM reponses ".
      "WHERE message_id = $message_id ".
      "GROUP BY accord ".
      "ORDER BY accord;";               //0=false=non puis 1=true=oui

$result=query($sqlbil);
if ($row1=mysql_fetch_array($result)) {
    if ($row2=mysql_fetch_array($result)) { // 2 lignes donc des oui et des non
        $nbnon=$row1["nbrep"];
        $nboui=$row2["nbrep"];  }
    else { //il n'y a que des oui ou que des non... mais on ne sait rien de plus !
        if ($row1["accord"]) { //on vient de trouver des 'true' (en fait des 1)
            $nboui=$row1["nbrep"];
            $nbnon=0;
            }
        else {
            $nbnon=$row1["nbrep"];
            $nboui=0;
            }
		}
   }
else { //ni oui ni non : pas de réponse des profs
    $nboui=0;
    $nbnon=0;
	}
return array($nboui,$nbnon);
}


function est_encours($eleve_id,$item_id) {
global $etab_nbj_vie_demande;
 $sql= "SELECT * FROM demandes ";
 $sql.="WHERE item_id=$item_id ";
 $sql.="  and eleve_id=$eleve_id ";
 $sql.="  and TO_DAYS(quand)-TO_DAYS(CURDATE())<=".$etab_nbj_vie_demande.
 $sql.="LIMIT 1;";
 // inutile de balayer toute la table : si on trouve une demande
 //de moins d'un mois, il n'y en a pas d'autre.
 $res=query($sql);
 $nblignes=mysql_num_rows($res);
 return $nblignes;
}

function est_interdit($item_id,$eleve_id) {
//non utilisé actuellement
return false;
}

function afficherreponses($eleve_id, $item_id, $comment=false) {
global $etab_nbj_vie_demande;
//Affichage des lignes associées à la demande dans le tableau reponses
//--------------------------------------------------------------------
//$comment est un booléen indiquant s'il faut afficher le commentaire
//pb curieux : impossible de remplacer reponses par r !
$sql="
     SELECT reponses.quand as rdate,
            accord, reponses.commentaire as rcomment,
            nom, prenom, civil
     FROM reponses, demandes d, profs p
     WHERE d.eleve_id   = $eleve_id
       and d.item_id    = $item_id
       and reponses.message_id = d.message_id
       and reponses.prof_id    = p.prof_id";
       //and TO_DAYS(CURDATE())-TO_DAYS(d.quand)<=".$etab_nbj_vie_demande.";";
$resrep=query($sql);

print "<table>\n";
// accord ; rdate ; civil nom prenom ; rcomment
print "<tr >\n";
print "<td class='rubrique'>Nom du professeur</td>\n";
print "<td class='rubrique'>Accord</td>\n";
print "<td class='rubrique'>Date réponse</td>";
if ($comment) print "<td class='rubrique'>Commentaire</td>";
print "</tr>";

$tparite=array("paire","impaire");
$parligne=0;
while ($rowrep=mysql_fetch_array($resrep)) {
    $parligne=1-$parligne;
    print "<tr class='".$tparite[$parligne]."'>\n";
    print "<td>\n".$rowrep["civil"]." ".$rowrep["nom"]." ".$rowrep["prenom"]."</td>\n";
    print "<td>\n";
    if ($rowrep["accord"]) print "oui</td>"; else print "non</td>\n";
    print "<td>\n".$rowrep["rdate"]."</td>\n";
    if ($comment) print "<td>\n".$rowrep["rcomment"]."</td>\n";
    print "</tr>\n";
}
print "</table>\n";
}

function affrepmessage($message_id,$comment=false) {
//Affichage des lignes associées à la demande dans le tableau reponses
//--------------------------------------------------------------------
//$comment est un booléen indiquant s'il faut afficher le commentaire
//pb curieux : impossible de remplacer reponses par r !
$sql="
     SELECT reponses.quand as rdate, accord, reponses.commentaire as rcomment,
            nom, prenom, civil
     FROM reponses
     LEFT  JOIN profs
     ON reponses.prof_id = profs.prof_id
     WHERE reponses.message_id = $message_id";

//on récupère les reponses des profs même disparus.

$resrep=query($sql);

print "<table>\n";
// accord ; rdate ; civil nom prenom ; rcomment
print "<tr class='rubrique'>\n";
print "<td>Nom du professeur</td>\n";
print "<td>Accord</td>\n";
print "<td>Date réponse</td>";
if ($comment) print "<td>Commentaire</td>";
print "</tr>";

$tparite=array("paire","impaire");
$parligne=0;
while ($rowrep=mysql_fetch_array($resrep)) {
    $parligne=1-$parligne;
    print "<tr class='".$tparite[$parligne]."'>\n";
    print "<td>\n";
    if (!isset($rowrep["nom"])) print "RIP";
    else print $rowrep["civil"]." ".$rowrep["nom"]." ".$rowrep["prenom"]."</td>\n";
    print "<td align='center'>\n";
    if ($rowrep["accord"]) print "oui</td>"; else print "non</td>\n";
    print "<td>\n".$rowrep["rdate"]."</td>\n";
    if ($comment) print "<td>\n".stripslashes($rowrep["rcomment"])."</td>\n";
    print "</tr>\n";
}
print "</table>\n";
}


function tuvous($tu,$vous) {
global $etab_vouvoyer_elev;
if ($etab_vouvoyer_elev) return $vous; else return $tu;
}




?>