<?php
#=
/*
Copyright 2002, Daniel Deycard, Jacques Messines, Stéphanie Roussel, Jean-Marie Treins
This file is part of GiBii/Melia.
GiBii/Melia is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

GiBii/Melia is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GiBii/Melia; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

****************************************************************************/


function purge_demrep($liste) {
$t=array_chunk($liste,100);
foreach($t as $tpart) {
	//print_r($tpart);
	$lpart=implode(",",$tpart);
	query("DELETE FROM reponses WHERE message_id IN ($lpart)");
	query("DELETE FROM demandes WHERE message_id IN ($lpart)");
	}
}	

//recherche si une demande doit être supprimée
//nacc0 est le nombre de refus, nacc1 le nombre d'accords,
//passage est un paramètre qui dit si on passe dans la page appelante pour la première fois
//si oui, on teste, sinon, c'est inutile de refaire
//nj est le nombre de jours écoulé depuis la demande
function est_perime($message_id,$eleve_id,$item_id,$disc_id,$nj,$nacc0,$nacc1,$passage) {
global $MODULE;
$asupp=false;
if (!isset($_SESSION[$passage])) {
    if ($nj>$_SESSION['etab_nbj_vie_demande']) {
    	//demande (non obtenue) ayant dépassé la durée limite étab
    	if ($nacc0==0 && $nacc1==0) {
			//demande sans réponse			
			$asupp=true;
			}
    	elseif ($nacc0>0) {
    			//au moins un refus : on annule la demande pour donner la possibilité à l'élève de la reformuler
    			$asupp=true;
    			}
    	elseif ($_SESSION['etab_profslongs']==0) {
    			//pas de demandes longues possibles dans l'étab
    			$asupp=true;
    			}
    	else {  //recherche de profs longs pour ce triplet (eleve_id, item_id, disc_id)
    			if ($MODULE=='Melia') $did=" AND profs.disc_id=$disc_id ";
    			else $did='';
				$reslong=query("
							SELECT DISTINCT profs.prof_id 
							FROM profs, lien_profs_classes, lpi, lien_eleves_classes
							WHERE lien_eleves_classes.eleve_id =$eleve_id
								AND lien_eleves_classes.classe_id = lien_profs_classes.classe_id
								AND lien_profs_classes.prof_id = lpi.prof_id
								AND lpi.item_id=$item_id
								AND lpi.prof_id = profs.prof_id
								AND profs.opt_dem1an =1
								AND lpi.prof_id = profs.prof_id
								$did
							");
				if (mysql_num_rows($reslong)<$_SESSION['etab_nb_validations']) {
					//pas assez de profs longs pour satisfaire la demande
					$asupp=true;
					}
				mysql_free_result($reslong);
				}
    	}
    }
return $asupp;
}
?>