<?php
#=
/****************************************************************************
Copyright 2002, Daniel Deycard, Jacques Messines, Alain Pomirol
(CATICE Académie de Bordeaux)

This file is part of GiBii/Melia.

GiBii/Melia is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

GiBii/Melia is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GiBii/Melia; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

****************************************************************************/

//TRAITEMENT VARS_ADM
//===================
if (!file_exists("../include/vars_adm.php")) {
    print "Le fichier vars_adm.php est absent du répertoire include<br />";
    print "Il semble que GiBii n'ait pas été installé.<br />";
    //copy("../include/vars_adm_safe.php","../include/vars_adm.php");
    exit();
}
//On peut intégrer maintenant
include("../include/vars_adm.php");
include("../include/util.inc.php");
include("../include/login.inc.php");
include("../include/scriptsql.php");
include("../include/utiljs.php");

$sadmin_mdp_chg=true;
connecte($host,$user,$mdp,$db);

//Lancement des mises à jour éventuelles
//Fichiers trouvés dans le dossier /sadmin/maj
//Uniquement les fichiers php (PHP ou PHP3)
$dir_source_maj="./maj";
$dir_cible_maj="./maj_faites";
clearstatcache();
if (!file_exists($dir_source_maj)) mkdir($dir_source_maj,0777);
if (!file_exists($dir_cible_maj)) mkdir($dir_cible_maj,0777);

if ($handle=opendir($dir_source_maj)) {
    while   ($fich=readdir($handle)) {
        $bout=explode(".",$fich);
        if ($bout) $ext=strtoupper($bout[count($bout)-1]);
        if ($fich !="." && $fich !=".." && ($ext=="PHP" || $ext=="PHP3"))
                $tab_fich[]=$fich;
        } //fin recherche fichiers
	}


//Vérif cohérence des versions de GiBii et du référentiel B2i
getparams();
$vv=verif_version();
if (!$vv) {
	alert("Incohérence entre votre version de GiBii ($VERSION_GIBII) et le référentiel du B2i ($VERSION_B2I)\nVous devez passer le script de conversion du référentiel sur la v. 4.7 avant de passer à la v. $VERSION_GIBII");
	exit;
	}


//inclusion des fichiers dans l'ordre alphabétique au cas où ça serait important..
//au passage on les envoie dans ./maj_faites
$revision=0;
if (isset($tab_fich)) {
    set_time_limit(0);
    session_start();
    sort($tab_fich);

    ?><!DOCTYPE HTML PUBLIC "-/W3C/DTD HTML 4.01 Transitional/EN">
    <html>
    <head>
    <meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
    <title>Ouverture de session sadmin</title>
    <link rel="stylesheet" href="../include/general.css">
    <base target='_self'>
    <script language="javascript" type="text/javascript" src="../include/md5.js"></script>
    <script language="javascript" type="text/javascript" src="../include/login.js"></script>
    </head>
    <body class="arial_sadmin" onload="document.formlogin.s_login.focus();">
	<h2>Mise à jour de la base</h2><hr />

    <?php
    //pour les scripts de maj, il faut quelques données
    //on ouvre une session qui ne sert que dans les fichiers de maj
    for ($nb_fichmaj=0;$nb_fichmaj<count($tab_fich);$nb_fichmaj++) {
        //inclusion fait un bête include (il est dans util.inc.php)
        $fichier=$tab_fich[$nb_fichmaj];
        //$revision devient une variable globale pour l'include qui suivra dans la boucle
        //ce ne sera utile que pour lorsque le script 99 sera inclus
        include($dir_source_maj."/".$fichier);
        $revision=(integer) substr($fichier,0,2); //pour que 02 devienne 2
        //Déplacement
        if (copy($dir_source_maj."/".$fichier,$dir_cible_maj."/".$fichier))
          	unlink($dir_source_maj."/".$fichier);
        }
    unset($_SESSION);  //on casse tout. index2.php fera le travail normal
    ?>
    <form name="houps" action="index2.php" method="post">
    <input type="submit" value="Continuer" />
    </form>
    </body>
    </html>
    <?php
    }
else {
    header("Location: ../sadmin/index2.php");
	}
?>
