<?php

//pas besoin : c'est fait !  (début)-----------------------------------------
//connecte($host, $user, $mdp, $db);
//set_time_limit(0);
//pas besoin : c'est fait !  (fin)-------------------------------------------


//___________________________________________________________________

//pour la fonction dedoub_resultats
//___________________________________________________________________
print "<br />Attention, la recherche des doublons dans les résultats peut durer une ou deux minutes...<br />";
superflush();
include("../sadmin/verifs.inc.php");
dedoub_resultats(true); //false= affichage par un alert js


//___________________________________________________________________

//09_tag_defaut_0
//___________________________________________________________________

//certaines bases ont encore des tags à NULL (dédoublonner rectifie) mais aussi
//le champ tag est indiqué comme défault NULL dans la base, ce qui fait que
//les individus créés à la main sont invisibles car leur tag=NULL

print "Changement de la valeur par défaut du tag pour d'anciens individus<br /><br />";
query("ALTER TABLE eleves CHANGE tag tag INT( 11 ) DEFAULT '0' NOT NULL");
query("ALTER TABLE profs CHANGE tag tag INT( 11 ) DEFAULT '0' NOT NULL");
query("UPDATE eleves SET tag=0 WHERE tag IS NULL");
query("UPDATE profs SET tag=0 WHERE tag IS NULL");

//___________________________________________________________________

//Fourchette du time-out de session
//___________________________________________________________________

$timeout_min=600; // 10 min
$timeout_max=7200; // 2 heures

$res=query("SELECT * FROM _params_globaux WHERE param_nom ='SESS_TIMEOUT_MIN'");
if (mysql_num_rows($res)==0) {
    query("INSERT INTO _params_globaux
                SET param_nom='SESS_TIMEOUT_MIN',
                    param_type='i',
                    param_val='$timeout_min',
                    param_desc='Valeur inférieure du time-out session imposé aux établissements (entre 2 demandes de page)',
                    param_tag=0");
    print "Création du champ SESS_TIMEOUT_MIN dans _params_globaux<br>";
    }

$res=query("SELECT * FROM _params_globaux WHERE param_nom = 'SESS_TIMEOUT_MAX'");
if (mysql_num_rows($res)==0) {
    query("INSERT INTO _params_globaux
                SET param_nom='SESS_TIMEOUT_MAX',
                    param_type='i',
                    param_val='$timeout_max',
                    param_desc='Valeur supérieure du time-out session imposé aux établissements (entre 2 demandes de page)',
                    param_tag=0");
    print "Création du champ SESS_TIMEOUT_MAX dans _params_globaux<br>";
    }

if (!champ_dans_table("sess_timeout","etablissements",$db)) {
    query("ALTER TABLE etablissements ADD sess_timeout INT NOT NULL DEFAULT '7200'");
    print "Création du champ sess_timeout (7200) dans la table etablissements <br>";
    }

//___________________________________________________________________

//06_erlog_completee
//___________________________________________________________________

//___________________________________________________________________

//Table des erreurs de logins (mot de passe erroné)
//___________________________________________________________________


function creer_erl() {
query("CREATE TABLE erreurs_logins (
                erid INTEGER NOT NULL AUTO_INCREMENT,
                quand DATETIME,
                compte_id VARCHAR(40),
                etab_id INTEGER,
                ip VARCHAR(40),
                code ENUM('ETB','LOG','GDS','MDP','PAG','PER','XSS ','TMO','STA','EXP'),
                login VARCHAR(30),
                nom VARCHAR(40),
                prenom VARCHAR(40),
                statut ENUM('Sadmin','Admin','Gestion','Prof','Eleve','') NOT NULL,
                etnom VARCHAR(40),
                etville VARCHAR(40),
                etcp VARCHAR(6),
                complet TINYINT NOT NULL DEFAULT 0,
				PRIMARY KEY  (`erid`),
    			KEY ix_etb (etab_id),
       			KEY ix_cpt (compte_id)
                )");
print "<br>Création de la table erreurs_logins<br>";
}



//------- départ --------

query("DROP TABLE IF EXISTS old");

if (table_dans_base('erreurs_logins',$db)) {
    if (!champ_dans_table('complet','erreurs_logins',$db))  {
        query("DROP TABLE erreurs_logins"); //vieille table incomplète (version 4.6 alpha)
        creer_erl();
        }
    }
else {
    creer_erl();
    }

//___________________________________________________________________

//04_grp_profs_menus_css
//___________________________________________________________________

if (!champ_dans_table("groupes_profs","etablissements",$db))  {
	    print "<br>Création du champ groupes_profs dans la table etablissements<br>";
query("ALTER TABLE `etablissements` ADD `groupes_profs` TINYINT DEFAULT '0' NOT NULL AFTER `result_profs`");
}
if (!champ_dans_table("menus_CSS","etablissements",$db))  {
query("ALTER TABLE `etablissements` ADD `menus_CSS` TINYINT DEFAULT '0' NOT NULL AFTER `theme`");
print "Création du champ menus_CSS dans la table etablissements<br>";
}



//___________________________________________________________________

//08_remplacement lien_profs_rubriques par lpi  (index)
//___________________________________________________________________


if (table_dans_base('lien_profs_rubriques',$db)) {
    query("DROP TABLE IF EXISTS lpi");
    query("CREATE TABLE IF NOT EXISTS lpi (
                prof_id INTEGER,
                item_id INTEGER,
                KEY IDX_lpi1(prof_id),
                KEY IDX_lpi2(item_id)
                )  TYPE=MYISAM
          ");
    query("DELETE FROM lpi"); //au cas où une ancienne existerait (erreur de 1ère exéc)
    //récupérer dans un tableau les items de chaque rubrique
    $res=query("INSERT INTO lpi SELECT profs.prof_id, items.item_id
                FROM lien_profs_rubriques AS lpr, items, profs
                WHERE items.rub_no=lpr.rub_no
                  AND profs.prof_id=lpr.prof_id ");
    query("DROP TABLE lien_profs_rubriques");
    print "<br>Remplacement de la table lien_profs_rubriques par la table lpi<br>";
    print "(les compétences des profs sont maintenant au niveau des items)";
    }




//___________________________________________________________________

//10_type_authent
//___________________________________________________________________

//Création de la table contenant les systèmes d'authentification

print "<br>Création ou modification des tables types_auth et params_auth<br>";

query("DROP TABLE IF EXISTS authentifications");
query("DROP TABLE IF EXISTS types_authentifications");
query("DROP TABLE IF EXISTS params_authentifications");
query("DROP TABLE IF EXISTS types_auth");
query("DROP TABLE IF EXISTS params_auth");

if (!table_dans_base('types_auth',$db)) {
         $sql_auth="CREATE TABLE types_auth (
    typauth_id INTEGER NOT NULL AUTO_INCREMENT,
    nom VARCHAR(40),
    extra VARCHAR(40),
    PRIMARY KEY (typauth_id));";

        query($sql_auth);
        query("INSERT INTO types_auth (nom) VALUES ('Interne')");
        query("INSERT INTO types_auth (nom) VALUES ('LDAP')");
        query("INSERT INTO types_auth (nom) VALUES ('CAS')");
        }

if (!table_dans_base('_params_auth',$db)) {
    $sql_auth2="CREATE TABLE _params_auth (
    param_id INTEGER NOT NULL AUTO_INCREMENT,
    etab_id INTEGER NOT NULL,
    param_nom VARCHAR(40),
    param_type ENUM('i','s','a'),
    param_val VARCHAR(40),
    param_desc VARCHAR(40),
    param_tag TINYINT DEFAULT -1,
    PRIMARY KEY (param_id),
    UNIQUE KEY ix_etb_n(etab_id, param_nom)
    )";

    query($sql_auth2);
    }


if (!champ_dans_table("typauth_id","etablissements",$db))  {
	print "<br>Création des champs typauth_id, tel_admin, mail_admin dans la table etablissements<br>";
    query("ALTER TABLE `etablissements` ADD `typauth_id` INTEGER DEFAULT '1' NOT NULL AFTER ville");
    query("ALTER TABLE `etablissements` ADD `tel_admin` VARCHAR(20) AFTER ville");
    query("ALTER TABLE `etablissements` ADD `mail_admin` VARCHAR(40) AFTER ville");
    }

//___________________________________________________________________

//Colonnes pour les stats par étab
//___________________________________________________________________

if (!champ_dans_table("recul_stats","etablissements",$db)) {
	    print "<br>Création du champs recul_stats dans la table etablissements<br>";
    query("ALTER TABLE etablissements ADD recul_stats INT NOT NULL DEFAULT '30'");
    }
if (!champ_dans_table("rub_simple","rubriques",$db)) {
    print "<br>Création du champs rub_simple dans la table rubriques<br>";
  	query("ALTER TABLE rubriques ADD rub_simple VARCHAR(55) NOT NULL");
    }

//Colonne obligatoire pour le calcul du C2i
if (!champ_dans_table("obligatoire","items",$db))   {
	print "<br>Création du champs obligatoire dans la table items<br>";
    query("ALTER TABLE `items` ADD `obligatoire` TINYINT DEFAULT '1' NOT NULL");
    $tab_obli=array(44,45,48,49,56,60,64,65,68);
    if ($MODULE=='GiCii') {
        //Attention au remplissage différent pour le c2i niveau 2 !
        foreach($tab_obli as $itob)
        	query("UPDATE items SET obligatoire=0 WHERE item_id=$itob");
        }
  }

//___________________________________________________________________

//paramètre des processus planifiés - nouveau en 4.6
//___________________________________________________________________

if (!champ_dans_table("last_proc_local","etablissements",$db)) {
	   print "<br>Mise en place de la 'planification' au login<br>";
	query("ALTER TABLE etablissements ADD last_proc_local DATETIME NOT NULL DEFAULT '2000-01-01 00:00:00'");
	}
if (mysql_num_rows(query("SELECT param_nom FROM _params_globaux WHERE param_nom='PERIODE_PROC_LOCAL'"))==0)
        query("INSERT INTO _params_globaux VALUES ('PERIODE_PROC_LOCAL','i','2','Processus local (étab) lancé tous les 2 jours (en principe !)', -1)");
if (mysql_num_rows(query("SELECT param_nom FROM _params_globaux WHERE param_nom='PERIODE_PROC_GLOBAL'"))==0)
        query("INSERT INTO _params_globaux VALUES ('PERIODE_PROC_GLOBAL','i','2','Processus global lancé tous les 2 jours (en principe !)', -1)");
if (mysql_num_rows(query("SELECT param_nom FROM _params_globaux WHERE param_nom='LAST_PROC_GLOBAL'"))==0)
        query("INSERT INTO _params_globaux VALUES ('LAST_PROC_GLOBAL','s','2000-01-01 00:00:00','Datetime du dernier lancement', -1)");


//___________________________________________________________________

//nouveau champ profs permettant la gestion des demandes jusqu'à 1 an
//___________________________________________________________________

if (!champ_dans_table("opt_dem1an","profs",$db)) {
	print "<br>Mise en place de la gestion des demandes longues pour les profs<br>";
	query("ALTER TABLE profs ADD opt_dem1an TINYINT NOT NULL DEFAULT '0'");

    //Suppression d'anciennes demandes réapparaissant suite au changement de stratégie
    //et faisant doublons avec une demande postérieure  (en gros 0,3 % des demandes)
    //___________________________________________________________________

    $resm=query ("SELECT DISTINCT d1.message_id
                FROM demandes AS d1, demandes AS d2
                WHERE d1.eleve_id = d2.eleve_id
                AND d1.disc_id = d2.disc_id
                AND d1.item_id = d2.item_id
                AND d1.message_id < d2.message_id");
    if (mysql_num_rows($resm))
    	print "<br>Suppression d'anciennes demandes réapparaissant et doublonnant suite au changement de stratégie<br>";
    while (list($mid)=mysql_fetch_array($resm)) {
        query("DELETE FROM demandes WHERE message_id=$mid");
        query("DELETE FROM reponses WHERE message_id=$mid");
        print "Suppression de message_id=$mid et de ".mysql_affected_rows()." réponses associées.<br />";
        }
	//Pour la mise en place de la nouvelle stratégie, on démarre sans les demandes "à durée longue"
	$resm=query("SELECT DISTINCT demandes.message_id
            FROM etablissements, eleves, demandes
            LEFT JOIN resultats ON resultats.item_id = demandes.item_id
            AND resultats.eleve_id = demandes.eleve_id
            WHERE etablissements.etab_id = eleves.etab_id
            AND eleves.eleve_id = demandes.eleve_id
            AND resultats.resultat_id IS NULL
            AND TO_DAYS(CURDATE())-TO_DAYS(demandes.quand ) > etablissements.nbj_vie_demande");
    if (mysql_num_rows($resm)) {
    	print "<br>Suppression d'anciennes demandes réapparaissant devenant 'demandes longues' suite au changement de stratégie<br>";
        print "(pas de retroactivité pour les demandes longues).<br>";
        }
	while (list($mid)=mysql_fetch_array($resm)) {
        query("DELETE FROM demandes WHERE message_id=$mid");
        query("DELETE FROM reponses WHERE message_id=$mid");
        print "Suppression de message_id=$mid et de ".mysql_affected_rows()." réponses associées.<br />";
    }

    }

//___________________________________________________________________

//Ajout d'une discipline
//___________________________________________________________________

if ($MODULE!='Melia' && mysql_num_rows(query("SELECT * FROM disciplines WHERE disc_id=58"))==0) {
	query("INSERT INTO disciplines SET disc_id=58,libelle='enseignant-éducateur'");
	print "<br>Ajout d'une discipline 'enseignant-éducateur'<br>";
	}

//___________________________________________________________________

//01_disc_gibii.php                On repasse une couche...
//___________________________________________________________________

//certaines tables demandes ont leur disc_id =0 voire NULL !
//
if (($MODULE=='GiBii') or ($MODULE=='GiCii')) {
  query("UPDATE demandes SET disc_id=-1");
  query("UPDATE resultats SET disc_id=-1");
	print "<br>Remise à plat de la discipline dans GiBii <br>";
}

//___________________________________________________________________

//On vire les anciennes stratégies  de stockage de brevets
//___________________________________________________________________

if (champ_dans_table("brevets","eleves",$db))
	query("ALTER TABLE `eleves` DROP `brevets`");

if (champ_dans_table("brev1","eleves",$db))
	query("ALTER TABLE `eleves` DROP `brev1` ,DROP `brev2` ,DROP `brev3`");



//___________________________________________________________________

//   Ajout de la version du B2i dans les params_globaux  pour savoir quel référentiel on a
//___________________________________________________________________


if (!isset($VERSION_B2I))  {
	print "<br>Ajout du champ 'VERSION_B2I' dans la table '_params_globaux'<br>";
  	query("INSERT INTO _params_globaux VALUES ('VERSION_B2I', 's', '2000', 'Version du référentiel (2000 ou 2006)', -1)");
   	//Pour l'instant on démarre en 2000, ce sera 2006 après la bascule du référentiel..
   	}


//___________________________________________________________________

// Création et remplissage de la table de stockage des brevets
//___________________________________________________________________

query("DROP TABLE IF EXISTS brevets");
print "<br>Création de la table 'brevets'<br>";
query("CREATE TABLE brevets (
          bid INTEGER NOT NULL AUTO_INCREMENT,
          eleve_id INTEGER NOT NULL,
          niveau TINYINT NOT NULL,
          datebrev DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
          PRIMARY KEY (bid),
          KEY IDX_eid(eleve_id))");

//Remplissage
//ATTENTION, ne doit absolument pas se lancer avec le nouveau référentiel, les règles changent !
if ((!isset($VERSION_B2I)) OR ($VERSION_B2I=='2000')) {
  print "<p class='rubrique'>Calcul et stockage de TOUS les brevets du site : </p>";
  //Fabrication d'une table temporaire pour stocker
  query("DROP TABLE IF EXISTS brevtemp");
  query("CREATE TABLE brevtemp (
            bid INTEGER NOT NULL AUTO_INCREMENT,
            eleve_id INTEGER NOT NULL,
            niveau TINYINT NOT NULL,
            datebrev DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
            nbrub INTEGER NOT NULL,
            nbit INTEGER NOT NULL,
            PRIMARY KEY (bid))");

  $resbrev1=query("INSERT INTO brevtemp
        SELECT NULL,eleve_id,'1',quand, count(DISTINCT(items.rub_no)) as nbrub, count(items.item_id) as nbit
        FROM resultats, items
        WHERE resultats.item_id=items.item_id
        AND resultats.item_id BETWEEN 1 AND 18
        GROUP BY  resultats.eleve_id
        HAVING nbrub=5
        AND nbit >14");
  $nb=mysql_affected_rows();
  print "Brevets de niveau 1... : $nb";

  $resbrev2=query("INSERT INTO brevtemp
        SELECT NULL,eleve_id,'2',quand, count(DISTINCT(items.rub_no)) as nbrub, count(items.item_id) as nbit
        FROM resultats, items
        WHERE resultats.item_id=items.item_id
        AND resultats.item_id BETWEEN 19 AND 36
        GROUP BY  resultats.eleve_id
        HAVING  nbrub =6
        AND nbit >14");
  $nb=mysql_affected_rows();
  print "<br>Brevets de niveau 2... : $nb";

  $resbrev3=query("INSERT INTO brevtemp
        SELECT NULL,eleve_id,'3',quand, count(DISTINCT(items.rub_no)) as nbrub, count(items.item_id) as nbit
        FROM resultats, items
        WHERE resultats.item_id=items.item_id
        AND resultats.item_id BETWEEN 37 AND 53
        GROUP BY  resultats.eleve_id
        HAVING nbrub =5
        AND nbit >13");
  $nb=mysql_affected_rows();
  print "<br>Brevets de niveau 3... : $nb";
  superflush();

  //On balance ce qu'il faut dans la table brevets
  //Inutile de la vider, la requête ne fait qu'ajouter ce qui n'y est pas (UNIQUE index eleve,niveau)

  query("ALTER TABLE `brevets` ADD UNIQUE `index_elid_niv` (`eleve_id`,`niveau`)");

  query("INSERT IGNORE INTO brevets
		SELECT NULL, eleve_id, niveau, datebrev
		FROM brevtemp");

	query("ALTER TABLE `brevets` DROP INDEX `index_elid_niv`");

  query("DROP TABLE brevtemp");
  }



//___________________________________________________________________

//   Champ comptabilisant les profs longs dans la table etablissements
//___________________________________________________________________


if (! champ_dans_table('profslongs','etablissements',$db)) {
    print "<br>Ajout du champ 'profslongs' dans la table 'etablissements'<br>";
	query("ALTER TABLE `etablissements` ADD `profslongs` INT NOT NULL DEFAULT '0'");
    }


//___________________________________________________________________

//   Table pour éviter pb de backup
//___________________________________________________________________


if (!table_dans_base('changements_logins',$db)) {
	query("CREATE TABLE changements_logins (
            etab_id INTEGER NOT NULL,
            loginold VARCHAR(30),
            loginnew VARCHAR(30),
            nom VARCHAR(30),
            prenom VARCHAR(30),
            statut VARCHAR(10),
            annee INTEGER,
            dateconnexion INTEGER)");
	}



?>