<?php
#=
/****************************************************************************
Copyright 2002, Daniel Deycard, Jacques Messines, Alain Pomirol
(CATICE Académie de Bordeaux)

This file is part of GiBii/Melia.

GiBii/Melia is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

GiBii/Melia is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GiBii/Melia; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

****************************************************************************/

include("../include/vars_adm.php");
include("../include/util.inc.php");
include("../include/utiljs.php");

connexion("$db");

$style="arial_sadmin";
opensession("Sadmin",false);
$PHP_SELF=basename($_SERVER['PHP_SELF']);
//Tableau des sécurités
$secureCNIL=Array(
        "AGREMENT_CNIL"=>"<b>La demande d'agrément à la CNIL a été satisfaite :</b>",
        "ENTREE_STRICTE"=>"Pas d'affichage du tableau des établissements en page d'accueil :",
        "IMPOSE_CHGT_MDP"=>"Obligation de changer le mot de passe à la première connexion :",
        "MDP_INIT_GEP"=>"Pas de mots de passe initiaux liés à la date de naissance (mais code complexe lié à l'identifiant GEP) :",
        "PAS_ITEM_MANUEL_GEST"=>"Pas de saisie directe d'items en mode gestion :",
        "PAS_ITEM_MANUEL_ADMIN"=>"Pas de saisie directe d'items en mode admin :",
        "PAS_SAUVE_LOCAL"=>"Sauvegardes SQL non transmises au client (elles restent sur le serveur) :",
        "PAS_IMPORT_EXPORT"=>"Pas d'import/export de résultats élèves :");

getparams(); //on récupère VERSION et DATE et MOIS_RENTREE et le reste

//DEBUG
//print_r($_POST);

if (!isset($traitaca)) {  //premier passage : on affiche le formulaire
//tableau des mois
$mois=array("1"=>"Janvier","Février","Mars","Avril","Mai","Juin","Juillet","Août","Septembre","Octobre","Novembre","Décembre");

print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
?><html>
<head>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
  <title>Options académiques</title>
  <link rel="stylesheet" href="../include/general.css" />
</head>
<body class="arial_sadmin">
     <p class=titre>Options globales</p>
    <form name="formaca" method="post" action="<?php echo "$PHP_SELF?statut=$statut"; ?>" >
    <input type="hidden" name="traitaca" value=1>
    <table border="1" cellspacing="0" bordercolordark="white" bordercolorlight="black" align="center" width="80%">
    <tr><td class="sadmin_light">
         <p align="center"><font color="white" size="3">
         <b>Gestion de l'année scolaire </b></font></p>
        </td>
    </tr>
    <tr><td>
       <p align="right">Premier mois de l'année scolaire&nbsp;&nbsp;
       <SELECT name="mois">
<?php
  //Boucle des mois
  for ($i=1;$i<13;$i++) {
    $sel=($MOIS_RENTREE==$i) ? "selected" : "";
    print "<option value=\"$i\" $sel>".$mois[$i]."</OPTION>\n";
    }
  ?>
    </SELECT><p><td><tr>
    <tr><td><p align="right">Adresse de messagerie du Super Admin de <?php print $MODULE; ?> :&nbsp;&nbsp;
        <input type="text" name="mail" size=35 <?php if (isset($MAIL_ADMIN)) print "value=\"$MAIL_ADMIN\""; ?> >
    <br><i> (pour les requêtes de fonctionnement) </i>
    </p></td></tr>
    <tr><td><p align="right">Adresse de messagerie du Service Responsable de <?php print $MODULE; ?> :&nbsp;&nbsp;
        <input type="text" name="mail_resp" size=35 <?php if (isset($MAIL_RESP)) print "value=\"$MAIL_RESP\""; ?> >
    <br><i> (pour les requêtes institutionnelles, les demandes CNIL etc..)</i>
    </p></td></tr>

    <tr><td><p align="right">Adresse postale du service <?php print $MODULE; ?> (par ex. Rectorat) :&nbsp;&nbsp;
        <input type="text" name="ptt" size=55 <?php if (isset($PTT_RESP)) print "value=\"$PTT_RESP\""; ?> >
    </p></td></tr>

    <tr><td><p>&nbsp;</p></td></tr>
    <tr><td class="sadmin_light">
         <p align="center"><font color="white" size="3">
         <b>Gestion de la sécurité (coché=sécurité renforcée)</b></font></p>
        </td>
    </tr>
<?php
foreach($secureCNIL as $key => $comment) {
  $check=((isset($$key)) && ($$key==1)) ? "checked" : "" ;
  print  "<tr><td><p align=\"right\">".$comment."&nbsp;&nbsp;\n";
  print "<input type=\"checkbox\" name=\"CB_".$key."\" ".$check.">\n";
  print "</p></td></tr>\n";
}

?>


    <tr><td><p align="right">Longueur minimale du mot de passe pour tout le site (0 = désactivé) :&nbsp;&nbsp;
        <input type="text" name="mdpmini" size=1 maxlength=1 <?php if (isset($MDP_MINI)) print "value=\"$MDP_MINI\""; else print "value=0"; ?> >
    </p></td></tr>
    <tr><td><p align="right">Les admins ne peuvent pas choisir un time-out de session utilisateur inférieur à <sup>(1)</sup> :&nbsp;&nbsp;
        <input type="text" name="sess_timeout_min" size=4 maxlength=5 <?php if (isset($SESS_TIMEOUT_MIN)) print "value=\"$SESS_TIMEOUT_MIN\""; else print "value=\"600\""; ?> >
    </p></td></tr>
    <tr><td><p align="right">Les admins ne peuvent pas choisir un time-out de session utilisateur supérieur à <sup>(1)</sup> :&nbsp;&nbsp;
        <input type="text" name="sess_timeout_max" size=4 maxlength=5 <?php if (isset($SESS_TIMEOUT_MAX)) print "value=\"$SESS_TIMEOUT_MAX\""; else print "value=\"7200\""; ?> >
    </p></td></tr>

    <tr><td><p>&nbsp;</p></td></tr>
    <tr><td><p align="right">La simplification des items par les administrateurs locaux est possible :&nbsp;&nbsp;
        <input type="checkbox" name="CB_SIMPLITEM" <?php if (isset($SIMPLITEM) && ($SIMPLITEM==1)) print "checked"; ?> value=1 >
    </p></td></tr>
    <tr><td><p align="right">La restauration d'une sauvegarde antérieure par les administrateurs locaux est possible :&nbsp;&nbsp;
        <input type="checkbox" name="CB_RESTORE" <?php if (isset($ADM_RESTORE) && ($ADM_RESTORE==1)) print "checked"; ?> value=1 >
    </p></td></tr>
    <tr><td><p>&nbsp;</p></td></tr>


    <tr><td align="center">
            <input type="submit" class="coul" name="btn_sauver" value="Enregistrement des paramètres">
            <input type="reset" class="coul" name="btn_reset" value="Valeurs précédentes">
        </td>
    </tr>
    <tr><td align="center">
            <input type="submit" class="coul" name="btn_retour" value="Retour sans enregistrement">
        </td>
    </tr>
     </table>
     </form>

    <p style="font-size: small;text-align: left;"><sup>(1)</sup> : <i>Dans chaque établissement, l'admin peut choisir
    la durée maximale entre deux demandes de pages par l'utilisateur (cette durée est
    appelée ici abusivement time-out de session). Les valeurs indiquées ici en secondes
    permettent de limiter ce time-out de façon que l'admin ne choisisse pas des
    valeurs déraisonnables. Valeurs d'origine : 10 minutes et 2 heures.</i>
    </p>
<?php        }

else { //traitement formulaire
    //========================
  if (isset($btn_sauver)) {
      $sqlsauve="UPDATE _params_globaux SET param_val=$mois ".
                 " WHERE param_nom='MOIS_RENTREE' ;";
      query($sqlsauve);
      if (isset($MAIL_ADMIN)) {
        $sqlsauve_mail="UPDATE _params_globaux SET param_val='$mail' ".
                       " WHERE param_nom='MAIL_ADMIN' ;";
        query($sqlsauve_mail);
        }
      else {
        $sqlsauve_mail="INSERT INTO _params_globaux ".
               " SET  param_nom='MAIL_ADMIN', ".
               "   param_type='s' , ".
               "   param_val='$mail' , ".
               "   param_desc='Adresse de messagerie de sadmin'";
         query($sqlsauve_mail);
         }
      if (isset($MAIL_RESP)) {
        $sqlsauve_mail="UPDATE _params_globaux SET param_val='$mail_resp' ".
                       " WHERE param_nom='MAIL_RESP' ;";
        query($sqlsauve_mail);
        }
      else {
        $sqlsauve_mail="INSERT INTO _params_globaux ".
               " SET  param_nom='MAIL_RESP', ".
               "   param_type='s' , ".
               "   param_val='$mail_resp' , ".
               "   param_desc='Adresse de messagerie du Responsable $MODULE'";
         query($sqlsauve_mail);
         }
      if (isset($PTT_RESP)) {
        $sqlsauve_resp="UPDATE _params_globaux SET param_val='$ptt' ".
                       " WHERE param_nom='PTT_RESP' ;";
        query($sqlsauve_resp);
      }
      else {
        $sqlsauve_resp="INSERT INTO _params_globaux ".
               " SET  param_nom='PTT_RESP', ".
               "   param_type='s' , ".
               "   param_val='$ptt' , ".
               "   param_desc='Adresse postale du Responsable $MODULE'";
         query($sqlsauve_resp);
         }

      //Paramètres de sécurité
      foreach($secureCNIL as $key => $comment) {
            $CBox="CB_".$key;
            if (isset($$CBox)) $$CBox=bool($$CBox); else $$CBox=0;
            if (isset($$key)) {
              $sqlsauve="UPDATE _params_globaux SET param_val='".$$CBox."' ".
                                " WHERE param_nom='$key' ;";
              query($sqlsauve);
            }
            else {
              $comment=addslashes($comment);
              $sqlsauve="INSERT INTO _params_globaux ".
                    " SET  param_nom='$key', ".
                    "   param_type='i' , ".
                    "   param_val=".$$CBox." , ".
                    "   param_desc='$comment'";
              query($sqlsauve);
            }
      } //Fin foreach

      //Securité :
      //Si on oblige au chgt de mdp au 1° login, il faut changer la val par défaut de 'actif' de comptes
     if  ($CB_IMPOSE_CHGT_MDP==1)
         query("ALTER TABLE `comptes` CHANGE `actif` `actif` INT( 11 ) DEFAULT '0' NOT NULL");
     else
             query("ALTER TABLE `comptes` CHANGE `actif` `actif` INT( 11 ) DEFAULT '1' NOT NULL");

      //Longueur mini du mdp
      if (isset($MDP_MINI))
          $sqlsauve="UPDATE _params_globaux SET param_val='$mdpmini' ".
                    " WHERE param_nom='MDP_MINI' ;";
      else
          $sqlsauve="INSERT INTO _params_globaux
                    SET  param_nom='MDP_MINI',
                    param_type='i' ,
                    param_val='$mdpmini' ,
                    param_desc='Longueur minimale du mot de passe'";
      query($sqlsauve);

      //fourchette time-out session
      if (isset($SESS_TIMEOUT_MIN))
          $sqlsauve="UPDATE _params_globaux SET param_val='$SESS_TIMEOUT_MIN'
                     WHERE param_nom='SESS_TIMEOUT_MIN' ;";
      else
          $sqlsauve="INSERT INTO _params_globaux
                    SET  param_nom='SESS_TIMEOUT_MIN',
                    param_type='i' ,
                    param_val='$SESS_TIMEOUT_MIN' ,
                    param_desc='Durée minimale entre 2 pages'";
      query($sqlsauve);

      if (isset($SESS_TIMEOUT_MIN))
          $sqlsauve="UPDATE _params_globaux SET param_val='$SESS_TIMEOUT_MAX'
                     WHERE param_nom='SESS_TIMEOUT_MAX' ;";
      else
          $sqlsauve="INSERT INTO _params_globaux
                    SET  param_nom='SESS_TIMEOUT_MAX',
                    param_type='i' ,
                    param_val='$SESS_TIMEOUT_MAX' ,
                    param_desc='Durée maximale entre 2 pages'";
      query($sqlsauve);

      //On peut simplifier les items ?
      if (!isset($CB_SIMPLITEM)) $CB_SIMPLITEM=0;
      if (isset($SIMPLITEM)) {
          $sqlsauve="UPDATE _params_globaux SET param_val=$CB_SIMPLITEM ".
                    " WHERE param_nom='SIMPLITEM';";
          //alert($sqlsauve);
          }
      else
          $sqlsauve="INSERT INTO _params_globaux SET  param_nom='SIMPLITEM',
                    param_type='i' ,
                    param_val=$CB_SIMPLITEM ,
                    param_desc='Les admins peuvent simplifier les items'";
      query($sqlsauve);

      //On peut restaurer dans les bahuts ?
      if (!isset($CB_RESTORE)) $CB_RESTORE=0; else $CB_RESTORE=1;
      if (isset($ADM_RESTORE)) {
          $sqlsauve="UPDATE _params_globaux SET param_val=$CB_RESTORE ".
                    " WHERE param_nom='ADM_RESTORE';";
          //alert($sqlsauve);
          }
      else
          $sqlsauve="INSERT INTO _params_globaux SET  param_nom='ADM_RESTORE',
                    param_type='i' ,
                    param_val=$CB_RESTORE ,
                    param_desc='Les admins peuvent restaurer une sauvegarde antérieure'";
      query($sqlsauve);

      //on peut envoyer la purée HTML à partir de là
      print "<html><head>\n";
      print "<title>Modification des paramètres globaux</title>\n";
      print "<link rel=\"stylesheet\" href=\"../include/general.css\">\n";
      print "</head>";
      print "<body class=\"arial_sadmin\">\n";
      print "<h2 align=\"center\">Modification des paramètres globaux</h2>\n";
      print "<p>&nbsp;</p>\n";
      print "Les nouveaux param&egrave;tres ont &eacute;t&eacute; sauvegard&eacute;s
             avec succ&egrave;s<br>";
      print "<form name=\"form1\" method=\"post\" action=\"sadmin_bas.php\">";
      print "<p align=\"center\">";
      print "<input type=\"submit\" class=\"coul\" name=\"envoi\" value=\"Suite\">";
      print "</p></form></body></html>";
    }
else {
      $cible="sadmin_bas.php";
      goto($cible);
}
} //fin traitement
 ?>
</body>
</html>