<?php
#=
/****************************************************************************
Copyright 2002, Daniel Deycard, Jacques Messines, Stphanie Roussel, Jean-Marie Treins
(CATICE Acadmie de Bordeaux)

This file is part of GiBii/Melia.

GiBii/Melia is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

GiBii/Melia is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GiBii/Melia; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

****************************************************************************/
include("../include/vars_adm.php");
include("../include/util.inc.php");
include("../include/get.inc.php");
include("../include/attestations.inc.php");
set_time_limit(600);
opensession("Admin",false);
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<HTML>
<HEAD>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
<TITLE>nom1</TITLE>
<BASE TARGET="_self">
<link rel="stylesheet" href="<?php echo "../themes/".$etab_theme."/b2i.css" ?>">
</HEAD>
<body class="arialadmin" link="white" vlink="white" alink="white">


<p class="sous_titre" align="center">Calcul et stockage des rsultats des 3 niveaux</p><hr>
<p align="left">
</p>
<p class='attention centre '>Veuillez patienter pendant le travail :</p>
<?php
print str_repeat("&nbsp;",200);
flush();

//Connexion  la base
$conn  = mysql_connect($host, $user, $mdp);
mysql_select_db($db, $conn) or die ("Impossible d'accder  $db");;


$nbitems=array();   // (une dimension : par niveau)
for ($i=1;$i<4;$i++) $nbitems[$i]=get_nbitems($i);

$rescla=query("SELECT divcod, classe_id FROM classes WHERE etab_id=$etab_id AND divgro='D' ORDER BY divcod");
//Recherche par classe

//Comptage !
$nbbrev=array(1=>0,2=>0,3=>0);
print "<br />Classes traites :&nbsp;&nbsp;&nbsp;";  //Pour remettre le curseur  gauche !

while (list($divcod,$clid)=mysql_fetch_array($rescla)) {
  //Prparation tableaux pour une classe (2 dimensions : niveau, lve)
  $tab_tag_eleve=array(array());    //Celui-l ne doit pas servir ici...
  $tab_eleveoui=array(array());     //Elves ayant ce niveau
  $tab_nbitems=array(array());      //nbitems obtenus par l'lve dans ce niveau
  //Remplissage des tableaux prcdents
  calcul_elev_nbitems($clid);  //Utile pour les pourcentages
  calcul_elev_attest($clid); //Calcul des attestations

  print $divcod."... ";
  flush();
  //A ce stade, on a toutes les infos, reste  remplir le tableau des lignes CSV lve par lve
  $reselev=query("SELECT eleve_id, nom, prenom, dnaiss FROM eleves WHERE classe_id=$clid AND annee=".ascol()."
                    ORDER BY nom, prenom");
  while (list($elid, $nm, $prnm, $ddn)=mysql_fetch_array($reselev)) {
    for ($n=1;$n<4;$n++) { //
        if (isset($tab_eleveoui[$n][$elid])) { //L on a un brevet, il faut le stocker !
			range_brevet($elid,$n);
			$nbbrev[$n]++;
        	}

        }

    }

}

//Affichage rsultats
print "<br /><br /><br />";
print "<center><br /><p class='avis_transparent'>Travail termin, voici le nombre actuel de brevets dlivrables :";
print "<table>";
for ($i=1;$i<4;$i++) print "<tr><td>".getlibellenivo($i)." : </td><td>".$nbbrev[$i]."</td></tr>";
print "</table></p>";

print "<form action='resultats.php'><BUTTON type=submit>Retour</BUTTON></form>";

print "</center>";


?>

</BODY>
</HTML>