<?php
#=
/****************************************************************************
Copyright 2002, Daniel Deycard, Jacques Messines, Stéphanie Roussel, Jean-Marie Treins
(CATICE Académie de Bordeaux)

This file is part of GiBii/Melia.

GiBii/Melia is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

GiBii/Melia is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GiBii/Melia; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

****************************************************************************/
include("../include/vars_adm.php");
include("../include/util.inc.php");
include("../include/get.inc.php");
include("../include/attestations.inc.php");
set_time_limit(600);
opensession("Admin",false);
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<HTML>
<HEAD>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
<TITLE>nom1</TITLE>
<BASE TARGET="_self">
<link rel="stylesheet" href="<?php echo "../themes/".$etab_theme."/b2i.css" ?>">
</HEAD>
<body class="arialadmin" link="white" vlink="white" alink="white">


<p class="sous_titre" align="center">Exportation des résultats de l'établissement au format CSV</p><hr>
<p align="left">
</p>
<p class='attention centre '>Veuillez patienter pendant la création du fichier CSV :</p>
<?php
print str_repeat("&nbsp;",200);
flush();

//Connexion à la base
$conn  = mysql_connect($host, $user, $mdp);
mysql_select_db($db, $conn) or die ("Impossible d'accéder à $db");;

//Préparation fichier csv
creertousrep("$DATA/$etab_rne/diplomes/");
$csv_file="$DATA/$etab_rne/diplomes/csv_result.csv";
$fcsv=fopen($csv_file,"w");

//Entêtes de colonnes
if ($MODULE=='GiBii') $tit='B2i '; elseif ($MODULE=='GiCii') $tit='C2i '; else $tit='CLV ';
$lignecsv="RNE;Divcod;Nom;Prénom;Dnaiss";
for ($i=1;$i<4;$i++) $lignecsv.=";%items $i;".$tit.getlibellenivo($i);
$lignecsv.="\n";
fputs($fcsv,$lignecsv);


$nbitems=array();   // (une dimension : par niveau)
for ($i=1;$i<4;$i++) $nbitems[$i]=get_nbitems($i);

$rescla=query("SELECT divcod, classe_id FROM classes WHERE etab_id=$etab_id AND divgro='D' ORDER BY divcod");
//Recherche par classe

print "<br />Classes traitées :&nbsp;&nbsp;&nbsp;";  //Pour remettre le curseur à gauche !

while (list($divcod,$clid)=mysql_fetch_array($rescla)) {
  $tab_lignes_csv=array();     //Préparation des lignes CSV, on l'écrira à la fin de chaque classe

  //Préparation tableaux pour une classe (2 dimensions : niveau, élève)
  $tab_tag_eleve=array(array());    //Celui-là ne doit pas servir ici...
  $tab_eleveoui=array(array());     //Elèves ayant ce niveau
  $tab_nbitems=array(array());      //nbitems obtenus par l'élève dans ce niveau


  //Remplissage des tableaux précédents
  calcul_elev_nbitems($clid);  //Utile pour les pourcentages
  calcul_elev_attest($clid); //Calcul des attestations

  print $divcod."... ";
  flush();
  //A ce stade, on a toutes les infos, reste à remplir le tableau des lignes CSV élève par élève
  $reselev=query("SELECT eleve_id, nom, prenom, dnaiss FROM eleves WHERE classe_id=$clid AND annee=".ascol()."
                    ORDER BY nom, prenom");
  while (list($elid, $nm, $prnm, $ddn)=mysql_fetch_array($reselev)) {
    //Préparation de la ligne pour $tab_lignes_csv
    $ligne="$etab_rne;$divcod;$nm;$prnm;$ddn;";
    for ($n=1;$n<4;$n++) { //pourcentages par niveau
        if (isset($tab_nbitems[$n][$elid])) $pourcent=$tab_nbitems[$n][$elid];
        else $pourcent=0;
        $nb=(int) $nbitems[$n];
        if ($nb>0) $pourcent= floor(($pourcent/$nb)*100); else $pourcent=0;
        $ligne.="$pourcent;";
        //Voir dans la table brevets d'abord !
        if (isset($tab_eleveoui[$n][$elid])) $mess="1"; else $mess="0";
        $ligne.=$mess.";";
        }
    $tab_lignes_csv[]=$ligne."\n";

    }

  //Ecriture fichier
  foreach ($tab_lignes_csv as $ligne)
           fputs($fcsv,$ligne);
}

fclose($fcsv);
//Affichage lien CSV
print "<br /><br />";
print "<center><br /><table width='40%' border='0'><tr><td width='85%'class='paire centre encadre_loin'>Pour accéder au fichier créé...</td><td class='centre paire encadre_loin'><a href='$csv_file' target=_blank ><img src=\"../themes/".$etab_theme."/csv.gif\" border='0'  alt='CSV'></a></td></tr></table></center>";

?>

</BODY>
</HTML>