<?php
#=
/****************************************************************************
Copyright 2002, Daniel Deycard, Jacques Messines, Stéphanie Roussel, Jean-Marie Treins
(CATICE Académie de Bordeaux)

This file is part of Gibii/Melia.

Gibii/Melia is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Gibii/Melia is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Gibii/Melia; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

****************************************************************************/
include("../include/vars_adm.php");
include("../include/util.inc.php");
include("../include/pdf.inc.php");
include("../include/get.inc.php");
$statut=$_REQUEST['statut'];
opensession($statut,false);


print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
?>
<html>

<head>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
<title>Diplomes</title>
<meta name="generator" content="amaya">
<link rel="stylesheet" href="<?php echo "../themes/".$etab_theme."/b2i.css" ?>">
<base target="_self">
<?php include("../include/utiljs.php"); ?>
</head>

<?php


print "<body class='arialgest'>";
include("../themes/".$etab_theme."/f_diplome.php");

echo "<p class='sous_titre'>Etat des attestations obtenues par les anciens élèves : </p><hr /> ";

//========================================================
//Recherche des élèves ayant le b2i dans la table résultat
//Choix du niveau de brevet ?
$brevet_no=$etab_niveau;
$PHP_SELF=basename($_SERVER['PHP_SELF']);
//Choix de la classe à afficher
if (!isset($niv)) {

switch ($brevet_no)  {
 case 'niv1': $niv="1"; break;
 case 'niv2': $niv="2"; break;
 case 'niv3': $niv="3"; break;
 case 'niv12':
      $niv='';
      print "<form name='formniv' method='post' action='".$PHP_SELF."?statut=$statut&classe_id=$classe_id&divcod=$divcod'>\n";
      print "<p align='center'>Choisissez le niveau à visualiser / imprimer : ";
      print "<select name='niv' value='' size='1'>\n";
      print "  <option value='1'>".getlibellenivo('niv1')."</option>\n";
      print "  <option value='2'>".getlibellenivo('niv2')."</option>\n";
      print "</select>&nbsp;&nbsp;\n";
      print "<input class='coul' type='submit' class='coul' name='btn_niv' value='Choix du Niveau'></p>\n";
      break;
 case 'niv23':
      $niv='';
      print "<form name='formniv' method='post' action='".$PHP_SELF."?statut=$statut&niv=$niv&classe_id=$classe_id&divcod=$divcod'>\n";
      print "<p align='center'>Choisissez le niveau à visualiser / imprimer : ";
      print "<select name='niv' value='' size='1'>\n";
      print "  <option value='2'>".getlibellenivo('niv2')."</option>\n";
      print "  <option value='3'>".getlibellenivo('niv3')."</option>\n";
      print "</select>&nbsp;&nbsp;\n";
      print "<input type='submit' class='coul' name='btn_niv' value='Choix du Niveau'></p>\n";
      break;
 case 'niv123':
      $niv='';
      print "<form name='formniv' method='post' action='".$PHP_SELF."?statut=$statut&niv=$niv&classe_id=$classe_id&divcod=$divcod'>\n";
      print "<p align='center'>Choisissez le niveau à visualiser / imprimer : ";
      print "<select name='niv' value='' size='1'>\n";
      print "  <option value='1'>".getlibellenivo('niv1')."</option>\n";
      print "  <option value='2'>".getlibellenivo('niv2')."</option>\n";
      print "  <option value='3'>".getlibellenivo('niv3')."</option>\n";
      print "</select>&nbsp;&nbsp;\n";
      print "<input type='submit' class='coul' name='btn_niv' value='Choix du Niveau'></p>\n";
      break;
      }
 print "<br /><p align='center'><i>Une fois le niveau choisi, patientez pendant la recherche, cela peut être un peu long...</i></p>";
 exit;
} // fin du choix du niveau qui est maintenant affecté    en 1 ou 2 ou autre...
 //bout de requête pour après
$rqniv="  and items.brevet_no = ".$niv;

$conn  = connecte($host, $user, $mdp, $db);

//Calcul nb d'items à avoir pour le brevet
$resit=query("select count(items.item_id)as nbitems, items.brevet_no ".
                     " from items where 1=1 ".
                     $rqniv." GROUP BY brevet_no");
$row=mysql_fetch_row($resit);
$nbitems=$row[0];
//Calcul nb de rubriques dans ce niveau de brevet
$resrub=query("SELECT DISTINCT rubriques.rub_no FROM rubriques,items
               WHERE rubriques.rub_no=items.rub_no
               AND items.brevet_no=$niv");
$nbrubric=mysql_num_rows($resrub);

//Préparation d'un tableau des élèves anciens de cet étab
$reseleves=query("select eleves.* from eleves
                  where eleves.annee!='$sess_ascol'
                  AND eleves.etab_id=$etab_id
                  order BY  eleves.annee DESC, nom, prenom;");
$nbelev=0;  //comptage des élèves
$oui_diplome=array();
while ($rowelev=mysql_fetch_array($reseleves)) {
  $eleid=$rowelev["eleve_id"];
  $eleve[]=$eleid;
  $elnom[]=$rowelev["nom"];
  $elprenom[]=$rowelev["prenom"];
  $elan[]=$rowelev["annee"];
  //Recherche des élèves n'ayant pas d'item dans ch. rubrique donc pas de diplome
  $sqlrudip="SELECT eleves.eleve_id, rubriques.rub_no, COUNT( resultat_id )  AS nb
            FROM eleves, resultats, items, rubriques
            WHERE eleves.eleve_id =$eleid AND eleves.eleve_id = resultats.eleve_id
            AND resultats.item_id = items.item_id AND items.rub_no = rubriques.rub_no
            AND brevet_no =$niv
            GROUP  BY rubriques.rub_no
            ORDER  BY rubriques.rub_no";
  $resrudip=query($sqlrudip);
  $nbrubricelev=mysql_num_rows($resrudip);
  $oui_diplome[$eleid]=($nbrubricelev==$nbrubric)? 1 : 0;
   $nbelev++;
}
//print_r($elnom);

echo "<p class='arial_petit centre'><SPAN class='warning'>Vous pouvez voir ou (ré)imprimer une attestation individuelle avec le lien sur le nom, uniquement si elle a été validée.</SPAN></p>";

$nbdip=0;  //on en profite pour compter les diplômes
//Préparer un tableau des diplômes
$reqdip= "select eleves.nom, eleves.prenom, eleves.annee, items.brevet_no, ".
        " eleves.eleve_id, count(resultats.item_id) as nbitems, ".
        " eleves.imp_diplome ".
        " from eleves, resultats, items ".
        " where  eleves.etab_id=$etab_id ".
        " and eleves.annee!='$sess_ascol' ".
        " and resultats.eleve_id=eleves.eleve_id ".
        " and resultats.item_id=items.item_id ".$rqniv.
        " GROUP BY resultats.eleve_id HAVING nbitems>=".$nbitems.
        " *0.8  ORDER BY eleves.nom, eleves.prenom";
$resdip=query($reqdip,$conn);
while ($rowdip=mysql_fetch_array($resdip)) {
    $eleve_id=$rowdip["eleve_id"];
    $prenom=$rowdip["prenom"];
    $tabprenom[]=$prenom;
    $nom=$rowdip["nom"];
    $tabnom[]=$nom;
    $an=$rowdip["annee"];
    //On n'imprime pas ici, simplement on prépare le tableau
    //On dégage ceux qui n'ont pas au moins un item par rubrique
    $oui_diplome[$eleve_id]=$oui_diplome[$eleve_id]+1;
    $nbdip++;
   }  //Fin du balayage diplômes
//print_r($oui_diplome);

//Affichage tableau des résultats
//En-tête du tableau

print "<p></p><center><table border='1' width='600' >\n";
print "<tr class='rubrique'>\n";
print "\t<td width='250' class='centre'>Elèves</td><td width='75' class='centre'>Année</td><td  class='centre'>Brevet de niveau ";
print getlibellenivo($niv)."</td>\n";
print "</tr>";
for ($i=0;$i<$nbelev;$i++) {
    //couleur de la ligne suivant l'année
    $cl=($elan[$i]%2==0) ? "paire" : "impaire";
    $elid=$eleve[$i];
    //$acquis=($oui_diplome[$elid]==2) ? "X" : "&nbsp;";
    //On va plutôt voir dans la table brevets
    $acquis=(getbrevet($elid,$niv)) ? "X" : "&nbsp;";
    $mode='un';
    if ($acquis=="X") print "<tr class=$cl><td><a href='imprimer_diplomes.php?mode=$mode&nom=".urlencode($elnom[$i])."&prenom=".urlencode($elprenom[$i])."&divcod=&niv=$niv&elid=$elid' target=_blank >&nbsp;".$elnom[$i]." ".$elprenom[$i]."</a></td><td class='centre'>".$elan[$i]."</td><td class='centre'>$acquis</td></tr>\n";
        else print "<tr class=$cl><td>&nbsp;".$elnom[$i]." ".$elprenom[$i]."</td><td class='centre'>".$elan[$i]."</td><td class='centre'>$acquis</td></tr>\n";
        }
//fin tableau
print "</table><br> ";
$s=($nbelev>1) ? "s" : "";
print $nbelev." élève$s ancien$s<br>";
$s=($nbdip>1) ? "s" : "";
print $nbdip." attestation$s obtenue$s<br> </center>";

?>

</body>

</html>