<?php
#=
/*
Copyright 2002-2004, Daniel Deycard, Jacques Messines, Stéphanie Roussel, Jean-Marie Treins
(CATICE Académie de Bordeaux)

This file is part of GiBii/Melia.
GiBii/Melia is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

GiBii/Melia is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GiBii/Melia; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

****************************************************************************/


if (!isset($getincphp)) {
$getincphp=1;

//recherche un établissemement (et en même temps stocke tous les résultats)
function getetab($etab_id) {
static $etablissements=array();
if (empty($etablissements)) {
    $res=query("SELECT etab_id,rne,nom,adresse,codepostal,ville
                  FROM etablissements");
    while (list($id,$rne,$nom,$adresse,$codepostal,$ville)
           =mysql_fetch_array($res)) {
            $etablissements[$id]['rne']=$rne;
            $etablissements[$id]['nom']=$nom;
            $etablissements[$id]['adresse']=$adresse;
            $etablissements[$id]['codepostal']=$codepostal;
            $etablissements[$id]['ville']=$ville;
    }
}
if (isset($etablissements[$etab_id]))
    return $etablissements[$etab_id];
else return false;
}

function get1etab($etab_id) { //comme l'autre mais ne conserve qu'UN seul établissement en var static
//permet de répondre aux demandes répétées du même étab
static $etablissement=array();
static $eid=0;
if ($etab_id==$eid) return $etablissement;
$eid=$etab_id;
$res=query("SELECT rne,nom,adresse,codepostal,ville FROM etablissements WHERE etab_id=$eid");
list($etablissement['rne'],$etablissement['nom'],$etablissement['adresse'],
     $etablissement['codepostal'],$etablissement['ville'])  = mysql_fetch_array($res);
if (isset($etablissement['rne'])) return $etablissement;
else return false;
}


function getrne($etab_id) {
$tabetab=getetab($etab_id);
return $tabetab['rne'];
}

//recherche d'une classe (et en même temps de toutes les classes) de l'établissement courant
function getclasse($classe_id) {
global $etab_id;
static $classes=array();
if (!isset($classes[$classe_id])) {
    $res=query("SELECT classe_id,divcod FROM classes WHERE etab_id=$etab_id");
    while (list($id,$divcod)=mysql_fetch_array($res))
          $classes[$id]=$divcod;
}
if (isset($classes[$classe_id])) return $classes[$classe_id];
else return false;
}

function getclasseid($divcod) {  //permet d'avoir tabid["4G3"]=6 par exemple
global $etab_id;
static $tabdivcod_classeid;
if (!isset($tabdivcod_classeid)) {
        $res=query("SELECT classe_id,divcod FROM classes where etab_id=$etab_id;");
        while (list($classe_id,$divcod)=mysql_fetch_array($res))
                $tabdivcod_classeid["$divcod"]=$classe_id;
        }
if (isset($tabdivcod_classeid["$divcod"])) return $tabdivcod_classeid["$divcod"];
else return false;
}


//cherche la discipline et récupère toutes les disciplines
function getdisc($disc_id) {
static $disciplines=array();
if (empty($disciplines)) {
    $res=query("SELECT disc_id,libelle FROM disciplines");
    while (list($id,$discipline)=mysql_fetch_array($res)) $disciplines[$id]=$discipline;
}
if (isset($disciplines[$disc_id])) return  $disciplines[$disc_id];
else return false;
}

//cherche le disc_id en fonction du code GEP (DISCCO) (et stocke le tableau)
function getdiscid($discco) {
static $tabdiscco_discid=array();
if (empty($tabdiscco_discid)) {
    $res=query("SELECT disc_id,gep_id FROM disc_gep;");
    while (list($disc_id,$gep_id)=mysql_fetch_array($res)) $tabdiscco_discid["$gep_id"]=$disc_id;
}
if (isset($tabdiscco_discid[$discco])) return $tabdiscco_discid[$discco];
else return false;
}

//spécifique Melia
function getlangue($langue_id) {
return getdisc($langue_id);
}

//récupérer les langues vivantes pratiquées par l'élève
function getlvchoix($eleve) {
$lvchoix=array();
$res4=query("SELECT rang, disc_id FROM lien_eleves_disciplines WHERE eleve_id=$eleve");
while (list($r,$d)=mysql_fetch_array($res4)) {
        $lvchoix[$r]=$d;
}
return $lvchoix;
}

//récupérer les langues vivantes pratiquées dans une classe
function getlvclasse($class_id) {
static $lvclasse=array();
global $etab_id;
$i=1;
if ($class_id!=0) {
  $res5=query("SELECT  DISTINCT disciplines.disc_id
        FROM disciplines, lien_eleves_disciplines, eleves, lien_eleves_classes
        WHERE disciplines.disc_id = lien_eleves_disciplines.disc_id
        AND lien_eleves_disciplines.eleve_id = eleves.eleve_id
        AND eleves.eleve_id=lien_eleves_classes.eleve_id
        AND lien_eleves_classes.classe_id=$class_id");
      }
else {
  $res5=query("SELECT  DISTINCT disciplines.disc_id
        FROM disciplines, lien_eleves_disciplines, eleves
        WHERE disciplines.disc_id = lien_eleves_disciplines.disc_id
        AND lien_eleves_disciplines.eleve_id = eleves.eleve_id
        AND eleves.etab_id=$etab_id");

}
while (list($lv)= mysql_fetch_array($res5)) {
    $lvclasse[$i]=$lv;
    $i++;
   }
return @$lvclasse;
}




//retourne nom prénom de l'élève $id (PAS DE STOCKAGE ICI (ce serait trop !))
function geteleve($id) {
 $sql="SELECT nom, prenom FROM eleves WHERE eleve_id=$id;";
 $res=query($sql);
 if (list($nm,$pre)=mysql_fetch_array($res)) return $nm." ".$pre;
 else return false;
}


//recherche d'élève connaissant son login
function geteleveid($login) {
global $etab_id;
$loginquot=addslashes($login);
$sql="SELECT * FROM comptes WHERE login='$login' and etab_id=$etab_id";
$res=query($sql);
if ($res) {
   $tab=mysql_fetch_array($res);
   if ($tab) $eleveid=$tab["eleve_id"];
   else $eleveid=0;
}
else $eleveid=0;
return $eleveid;
}

//retourne nom prénom du prof  $id
function getprof($id) {
 $sql="SELECT civil, nom, prenom, annee FROM profs WHERE prof_id=$id;";
 $res=query($sql);
 if (list($civ,$nm,$pre,$an)=mysql_fetch_array($res))
    return $civ." ".$pre." ".$nm." ($an)";
 else return false;
}

//fonctions de calcul par étab et par classe si $classid existe

function getnbeleves_old($etab,$classid=0) {
  //On suppose la connexion ouverte
  //si on donne un id de classe, on obtient le nb des élèves de la classe
  global $sess_ascol;
  if ($classid>0) $comp=" and classe_id=$classid ";
     else $comp="";
  $sql="SELECT eleve_id FROM eleves WHERE etab_id=$etab and annee='$sess_ascol'".$comp." ;";
  $res=query($sql);
  if ($res) $nb=mysql_num_rows($res);
      else $nb=0;
  return $nb;
}


function getnbeleves($etab,$classid=0) {
  //On suppose la connexion ouverte
  //si on donne un id de classe, on obtient le nb des élèves de la classe
  global $sess_ascol;
  if ($classid==0) {   //nb élèves de l'étab
          $sql="SELECT eleve_id FROM eleves WHERE etab_id=$etab and annee='$sess_ascol'";
          }
     else {
             $sql="SELECT eleves.eleve_id FROM eleves, lien_eleves_classes WHERE etab_id=$etab
                and annee='$sess_ascol'
                and lien_eleves_classes.eleve_id=eleves.eleve_id
                and lien_eleves_classes.classe_id=$classid";
          }
  $res=query($sql);
  if ($res) $nb=mysql_num_rows($res);
      else $nb=0;
  return $nb;
}

function getnbclasses($etab_id) {
 //retourne le nb de classes de l'établissement
 $sql="SELECT * FROM classes WHERE  etab_id=$etab_id AND divgro='D'";
 $res=query($sql);
 if ($res) $nb=mysql_num_rows($res);
    else $nb=0;
 return $nb;
}


function getnbelevesactifs($etab,$classid=0) {
  //On suppose la connexion ouverte
  //si on donne un id de classe, on obtient le nb des élèves de la classe
  global $sess_ascol,$sum;
  if ($classid>0) $comp=" and eleves.eleve_id=lien_eleves_classes.eleve_id
                          and lien_eleves_classes.classe_id=$classid ";
     else $comp="";
  $sql="SELECT eleves.eleve_id, comptes.actif FROM eleves, comptes, lien_eleves_classes  ".
       " WHERE eleves.etab_id=$etab ".
       " and eleves.eleve_id=comptes.eleve_id ".
       " and annee='$sess_ascol'".
       " and comptes.actif>-1 ".$comp." ;";
  $res=query($sql);
  if ($res) $nb=mysql_num_rows($res);
      else $nb=0;
  while (list($el,$act)=mysql_fetch_array($res)) $sum+=$act;
  return $nb;
}

function getnbprofs($etab) {
  //On suppose la connexion ouverte
  global $sess_ascol;
  $sql="SELECT prof_id FROM profs WHERE etab_id=$etab and annee='$sess_ascol';";
  $res=query($sql);
  if ($res) $nb=mysql_num_rows($res);
      else $nb=0;
  return $nb;
}

function getnivo($rub) {
static $niv=array();
if (empty($niv)) {
    //On suppose la connexion faite
    $res=query("SELECT  DISTINCT brevet_no, rub_no FROM items ORDER  BY rub_no;");
    while ($row=mysql_fetch_array($res)) {
      $br=$row['brevet_no'];
      $ru=$row['rub_no'];
      $niv[$ru]=$br;
      }
  }
return $niv[$rub];
}


function getlibellenivo($niv) { //retourne le libellé du niveau suivant le Module où on se trouve
                                  //et suivant le niveau requis : gère le multi niveaux...
global $MODULE;
switch ($MODULE) {
     case "GiBii" :
       $libelle=array(1=>"École","Collège","Lycée-CFA");
       break;
     case "Melia" :
       $libelle=array(1=>"Niveau 1","Niveau 2","Niveau 3");
       break;
     case "GiCii" :
       $libelle=array(1=>"Niveau 1","Niveau 2","Niveau 3");
       break;
     default :
       $libelle=array(1=>"Niveau 1","Niveau 2","Niveau 3");
}

if (($niv=="niv1") or ($niv==1)) return $libelle[1];
if (($niv=="niv2") or ($niv==2)) return $libelle[2];
if (($niv=="niv3") or ($niv==3)) return $libelle[3];
if ($niv=="niv12") return $libelle[1]." &amp; ".$libelle[2];
if ($niv=="niv23") return $libelle[2]." &amp; ".$libelle[3];
if ($niv=="niv123") return $libelle[1]." &amp; ".$libelle[2]." &amp; ".$libelle[3];
}

function get_nbrubric() { //retoune le nb de rubriques dans ch niveau
static $nbr=array();                // dans un tableau
if (empty($nbr)) {
     //Calcul nb de rubriques dans ce niveau connexion faite dans l'appelant
     $resrub=query("SELECT  DISTINCT rubriques.rub_no, items.brevet_no
             FROM rubriques, items   WHERE rubriques.rub_no = items.rub_no ORDER  BY items.brevet_no");
     for ($i=1;$i<4;$i++) $nbr[$i]=0;
     while (list($rno,$bno)=mysql_fetch_array($resrub)) $nbr[$bno]++;
     }
return $nbr;
}

function get_nbit_parrub() {
//retourne le nb d'items par rubrique
static $nbit_parrub=array();
if (empty($nbit_parrub)) {
  $resitrub=query("SELECT rub_no, count(item_id) as nbitems FROM items
		WHERE obligatoire=1 GROUP BY rub_no");
  while (list($rub, $nb)=mysql_fetch_array($resitrub)) $nbit_parrub[$rub]=$nb;
}
return $nbit_parrub;
}

function get_rub_items($et_niv, &$tab_r, &$tab_r_id, &$tab_i, &$tab_i_id, &$nbits) {
//remplit un tableau des rubriques et items de l'étab

switch ($et_niv) {
    case "niv1": $condition=" AND brevet_no=1 ";break;
    case "niv2": $condition=" AND brevet_no=2 "; break;
    case "niv3": $condition=" AND brevet_no=3 "; break;
    case "niv12"  : $condition=" AND (brevet_no=1 || brevet_no=2) "; break;
    case "niv23"  : $condition=" AND (brevet_no=2 || brevet_no=3) "; break;
    default: $condition="";
}

//obtenir les rubriques du brevet $brevet_no
$resrub=query("select DISTINCT rubriques.rub_no, rubriques.libelle " .  //nb d'items/rubrique
              "from rubriques, items ".
              "where rubriques.rub_no=items.rub_no ".$condition.
              " order by rubriques.rub_no;");


$nbrub=0;
while (list($rub_id,$rub)=mysql_fetch_array($resrub))  {
       $nbrub++;
       $tab_r[$nbrub]=$rub;
       $tab_r_id[$nbrub]=$rub_id;
       //Et les items ?
       $resit=query("SELECT DISTINCT items.item_id, libelles.inst FROM items, libelles
              WHERE items.item_id=libelles.item_id
              AND items.rub_no=$rub_id
              ORDER BY items.s_rub_no");
       $nbit=0;
       while (list($itid, $itlib)=mysql_fetch_array($resit)) {
             $nbit++;
             $tab_i[$nbrub][$nbit]=$itlib;
             $tab_i_id[$nbrub][$nbit]=$itid;
               }
       $nbits[$nbrub]=$nbit;
       }

}

function get_nbitems($n) {  //retourne le nb d'items obligatoires pour ce niveau
global $MODULE;       //Voir si pareil pour GiBii GiCii Melia ?????
$wher=" WHERE obligatoire=1 ";
static $nbitems=array();
if (empty($nbitems)) {
      //Calcul nb d'items pour ce niveau de b2i
      $resit=query("select count(items.item_id)as nbitems, items.brevet_no ".
                     " FROM items ".
                     $wher.
                     " GROUP BY brevet_no");
      while (list($nb, $ni)=mysql_fetch_row($resit))
              $nbitems[$ni]=$nb;
      }
return @$nbitems[$n];
 }

function getbrevet($el,$n) {
//retourne vrai si brevet acquis pourl'élève $el et le niveau $n
//en allant voir dans la table brevets
$resbrev=query("SELECT * FROM brevets
		WHERE eleve_id=$el
		AND niveau=$n");
$nb=mysql_num_rows($resbrev);
if ($nb==0) return false;
else return true;
}

function getBrevetFromNiv() {
switch ($_SESSION['etab_niveau'])  {
      case 'niv1': return 'items.brevet_no = 1'; break;
      case 'niv2': return 'items.brevet_no = 2';  break;
      case 'niv3': return 'items.brevet_no = 3';  break;
      case 'niv12':return 'items.brevet_no IN (1,2)'; break;
      case 'niv23':return 'items.brevet_no IN (2,3)'; break; //plus rapide
      default: return '1';
      }
}

} //non, cette accolade n'est pas en trop !
?>