<?php
#G
#=
/****************************************************************************
Copyright 2002, Daniel Deycard, Jacques Messines, Stéphanie Roussel, Jean-Marie Treins
(CATICE Académie de Bordeaux)

This file is part of Gibii/Melia

Gibii is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Gibii is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Gibii; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

****************************************************************************/

//Fonctions de suppression diverses (élèves, profs, classes, étabs)

function suppr_eleve($elid,$mode) {   //mode!=0 mode bavard
    $ok=true;
    $nom_elev=geteleve($elid);
    //Effacement dans les tables annexes

    query("DELETE FROM comptes WHERE eleve_id=$elid;");
    $resdem=query("SELECT message_id FROM demandes WHERE eleve_id=$elid;");
    while (list($message_id)=mysql_fetch_array($resdem)) {
      query("DELETE FROM reponses WHERE message_id=$message_id;");
      }
    query("DELETE FROM brevets WHERE eleve_id=$elid;");
    query("DELETE FROM demandes WHERE eleve_id=$elid;");
    query("DELETE FROM resultats WHERE eleve_id=$elid;");
    query("DELETE FROM lien_eleves_disciplines WHERE eleve_id=$elid;");
    query("DELETE FROM lien_eleves_classes WHERE eleve_id=$elid;");

    //Fin : on vire l'élève
    $sql_elev="DELETE FROM eleves WHERE eleve_id=$elid ;";
    $ok=query($sql_elev);
    if (!$ok) $bilan="<br>Erreur dans la suppression du compte élève  !";
           else $bilan="<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;- Compte élève $nom_elev supprimé.";
     if ($mode!=0) return $bilan;
}

function suppr_classe($id,$mode) {   //Mode=0 Un retour par classe
                                     //Mode=1 Un retour par élève
    global $etab_id;
    $divcod=getclasse($id);
    $ok=true;
    if ($mode==1) $modelev=1; else $modelev=0;

    //recherche des classes pour effacer chaque élève
    //retourne un message + ou moins précis suivant $mode
    $sql_elev="SELECT eleves.*, comptes.login  FROM eleves, comptes, lien_eleves_classes ".
        " WHERE eleves.eleve_id=comptes.eleve_id ".
        " AND eleves.eleve_id=lien_eleves_classes.eleve_id ".
        " and eleves.etab_id=$etab_id and lien_eleves_classes.classe_id=$id ;";
    $res_elev=query($sql_elev);
    $mess="<br><b>Suppression des élèves de $divcod...</b>";
    while ($rowelev=@mysql_fetch_array($res_elev)) {
      $eleve_id=$rowelev["eleve_id"];
      $compte_id= $rowelev["compte_id"];
      $login=$rowelev["login"];
      //Suppression de l'élève eleve_id (sauf elève test)
      if (($login!="00000") && (isset($eleve_id)))
      $mess.=suppr_eleve($eleve_id,$modelev); //Suivant appel $mode
    }
    //Suppression dans liens profs-classes  puis dans classes
    query("DELETE FROM lien_profs_classes WHERE classe_id=$id ;");
    if ($divcod!="Classe_Test") {
      $sqlclasse="DELETE FROM classes WHERE classe_id=$id ;";
      $ok=query($sqlclasse);
      //Au cas où, ça a dû partir avec les élèves...
      query("DELETE FROM lien_eleves_classes WHERE classe_id=$id");

      if (!$ok) $mess.="<br>Erreur dans la suppression de la classe $divcod !";
           else $mess.="<br><b>* Classe $divcod supprimée.</b>";
    } else $mess.="<br><b>* Classe $divcod conservée (avec 00000).</b>";
    return $mess;
}

function suppr_profs($mode) {  //mode 0 = muet 1= bavard 1 ligne par prof
   global $etab_id;
   $ok=true;
   //recherche des profs
   //pour traiter les tables de liens
   $sql_prof="SELECT profs.prof_id, login FROM profs, comptes ".
    " WHERE profs.prof_id=comptes.prof_id and profs.etab_id=$etab_id ;";
   $res_prof=query($sql_prof);
   $mess="<br><b>Suppression des comptes des professeurs...</b>";
   while (list($prof_id, $login)=@mysql_fetch_array($res_prof)) {
     $nom_prof=getprof($prof_id);
     if ($login!="proftest") {
      //effacement dans les tables annexes puis profs et comptes
      query("DELETE FROM lien_profs_classes WHERE prof_id=$prof_id;");
      query("DELETE FROM lpi WHERE prof_id=$prof_id;");
      query("DELETE FROM profs WHERE prof_id=$prof_id;");
      query("DELETE FROM comptes WHERE prof_id=$prof_id;");
      if ($mode!=0) $mess.="<br> - Compte professeur $nom_prof supprimé.";
      }
   } //fin while
   $mess.="<br><b>Tous les comptes professeurs sont supprimés (sauf proftest !)</b>";
    return $mess;
}

?>