<?php
#=
/****************************************************************************
Copyright 2002, Daniel Deycard, Jacques Messines, Alain Pomirol
(CATICE Académie de Bordeaux)

This file is part of Gibii.

Gibii is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Gibii is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Gibii; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

****************************************************************************/
include("../include/vars_adm.php");
include("../include/util.inc.php");
include("../include/utiljs.php");
include("bilan.inc.php");

opensession("Prof");
connecte($host,$user,$mdp,$db);

if (isset($CBRep)) {
    //On récupère les tableaux CBRep[], eleve[], item[], disc[], demande[]
    /*print_r($CBRep);print "<br><br>";
    print_r($eleve);print "<br><br>";
    print_r($item);print "<br><br>";
    */
    foreach($CBRep as $rid => $accord) {
        $eleve_id=$eleve[$rid];
        $item_id=$item[$rid];
        $discipline=$disc[$rid];
        $message_id=$demande[$rid];
	    //enlever la réponse que désire le prof
	    query("DELETE FROM reponses WHERE reponse_id=$rid");

        $obtenu=mysql_num_rows(query("SELECT * FROM resultats
	                                  WHERE item_id=$item_id
	                                    AND eleve_id=$eleve_id
	                                    AND disc_id=$discipline"));
        if ($accord) {
	        //chercher si la réponse n'a pas impliqué un item
	        if ($obtenu) {
	            //il y a eu un item accordé. Il faut recalculer le bilan-1
	            //au cas où d'autres profs auraient misé après celui-ci
	            list($nbacc,$nbrefus)= tabAccRefus($message_id);
	            $bilan=$nbacc-$nbrefus;
	            if (!estAccordable($bilan,$eleve_id,$item_id,$discipline)) {
	                // l'item est immérité !
	                //on le supprime. Si l'élève a réussi entre-temps à faire
	                //imprimer son brevet, il va y avoir un scandale au bahut.
	                query("DELETE FROM resultats WHERE eleve_id=$eleve_id
	                                             AND item_id=$item_id
	                                             AND disc_id=$discipline");
	                }
	            }
	        }
	    else {
	    	//réponse négative
	    	//chercher si la suppression d'une réponse négative n'a pas permis d'apporter un résultat
	    	if (!$obtenu) {
	    		list($nbacc,$nbrefus)= tabAccRefus($message_id);
	            $bilan=$nbacc-$nbrefus;
	    		if (estAccordable($bilan,$eleve_id,$item_id,$discipline)) {
	    			query("INSERT INTO resultats WHERE eleve_id=$eleve_id
	    											AND item_id=$item_id
	                                             	AND disc_id=$discipline");
	                }
	            }
	        }
        }
	header("Location: prof_bas.php");
}


//passage 1 : formulaire
print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
?>
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
<title>B2i - Dévalidation de réponses récentes</title>

<link rel="stylesheet" href="<?php echo "../themes/".$etab_theme."/b2i.css" ?>" />
</head>

<?php
print "<body class=\"arialprof\"
             text=\"black\" link=\"blue\" vlink=\"purple\" alink=\"red\">";
print "<p class=\"sous_titre\">Validations effectuées récemment</p>\n";

$prof_id=$_SESSION['sess_mec_id'];
$res=query("SELECT reponse_id,accord,reponses.quand,reponses.commentaire,
                   libelles.base,
                   eleves.eleve_id,eleves.nom,eleves.prenom,
                   classes.divcod,
                   demandes.message_id,demandes.disc_id,demandes.commentaire,
                   items.item_id
            FROM  reponses
                  LEFT JOIN demandes ON demandes.message_id=reponses.message_id
                  LEFT JOIN items ON items.item_id=demandes.item_id
                  LEFT JOIN libelles ON libelles.item_id=items.item_id
                  LEFT JOIN eleves ON eleves.eleve_id=demandes.eleve_id
                  LEFT JOIN classes ON classes.classe_id=eleves.classe_id
            WHERE prof_id=$prof_id
              AND (TO_DAYS(CURDATE())-TO_DAYS(reponses.quand))<=2");
if (mysql_num_rows($res)==0) {
    alert("Pas d'accord récent à supprimer");
    goto("prof_bas.php");
    print "</body></html>";
    }

print "<p class=\"attention avis\">\n";
print "Les réponses négatives aux items n'apparaissent pas dans la liste ci-dessous.<br/>
       Si vous désirez annuler une réponse négative, accordez l'item puis supprimez dans cette page la réponse positive !\n";
print "</p><br/>";

print "<form action=\"#\" method=\"post\">\n";
print "<div align='center'><table border=1>\n";
print "<tr class='rubrique'><th>Dévalider</th><th>Réponse</th><th>Quand</th><th>Nom</th><th>Prénom</th><th>Classe</th><th>[n° item] - Libellé item</th><th>moi</th><th>lui</th>\n";
print "</tr>\n";

while (list($rid,$accord,$quand,$commentp,$libitem,$eleve_id,$nom,$prenom,$divcod,$demande,$disc,$commente,$item)=mysql_fetch_array($res)) {
    //if ($accord==0) continue;
    if (!$commentp) $commentp="&nbsp";
    if (!$commente) $commente="&nbsp";
    print "<tr><td class=\"centre\"><input type=\"checkbox\" name=\"CBRep[$rid]\" value=\"$accord\">";
    print "<input type=\"hidden\" name=\"eleve[$rid]\" value=\"$eleve_id\">\n";
    print "<input type=\"hidden\" name=\"item[$rid]\" value=\"$item\">\n";
    print "<input type=\"hidden\" name=\"disc[$rid]\" value=\"$disc\">\n";
    print "<input type=\"hidden\" name=\"demande[$rid]\" value=\"$demande\">\n";
    print "</td>\n";
    print "<td class=\"centre\">";
	if ($accord) 
		print "<img align=\"absmiddle\" border='0' width='20' height='20' title=\"accordé\" src='../themes/".$etab_theme."/btn_val_ok.gif' />";
	else
		print "<img align=\"absmiddle\" border='0' width='20' height='20' title=\"refusé\" src='../themes/".$etab_theme."/btn_val_no.gif' />";
    print "<td class=\"centre\">$quand</td>\n";
    print "<td>&nbsp;$nom</td>\n";
    print "<td>&nbsp;$prenom</td>\n";
    print "<td>$divcod</td>\n";
    print "<td>[$item] - $libitem</td>\n";
    print "<td>$commentp</td>\n";
    print "<td>$commente</td>\n";
    print "</tr>\n";
    }
print "</table>";
print "<p><table border=\"0\" ><tr><td><input class=\"coul\" type=\"submit\" name=\"deval\" value=\"Supprimer des réponses cochées\" /></td>\n";
print "<td><input class=\"coul\" type=\"reset\" value=\"Décocher tout\" /></td></tr></table></p></div>\n";

?>
</body>
</html>