<?php
#=
/****************************************************************************
Copyright 2002, Daniel Deycard, Jacques Messines, Alain Pomirol
(CATICE Académie de Bordeaux)

This file is part of Gibii.

Gibii is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Gibii is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Gibii; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

***************************************************************************

Contribution benoit.ducange@ac-amiens.fr

****************************************************************************/
include("../include/vars_adm.php");
include("../include/util.inc.php");
include("../include/get.inc.php");
include("../include/attestations.inc.php");

//ouverture de la session
opensession("Prof",false);

?>
<?php
    print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
?>
<html><head>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
<title>Texte de la rubrique 1</title>
<link rel="stylesheet" href="<?php echo "../themes/".$etab_theme."/b2i.css" ?>">
<?php include("../include/utiljs.php"); ?>

</head>

<body class="arialprof" bgcolor="white" text="black" link="blue" vlink="purple" alink="red">

<?php
$prof_id=$sess_mec_id;

//Fonction locale
function reponse_prof($profid, $messid) {   //Savoir si profid a déjà donné une validation OUI à ce message
  global $host, $user, $mdp, $db;
  $deja_accord=false;
  $sqlprof="SELECT * FROM reponses WHERE prof_id=$profid and message_id=$messid and accord=1;";
  $resprof=query($sqlprof);
  if ($rowprof=mysql_fetch_array($resprof)) $deja_accord=true;
  return $deja_accord;
               }


/////////////////////////
// programme principal //
/////////////////////////
echo '<body class="arialprof" text="black" link="blue" vlink="purple" alink="red">';

print "<p class='sous_titre'><i>Valider des items sans demande préalable</i><br></p>";
print "<p class='warning'>Dans le cas de plusieurs items pour plusieurs élèves, l'affichage risque être long : ";
print "attendez le bouton \"Retour\" en bas de page pour continuer !</p>";
print "<p class='attention'>Vous avez validé les items :</p>";

$conn  = connecte($host, $user, $mdp, $db);
$aujourdhui = date("d/m/Y");

//Recherche nom du prof demandeur
$res_prof=query("SELECT civil, prenom, nom, disc_id ".
                        "FROM profs ".
                        "WHERE prof_id=$prof_id");
list($civ, $pren, $nomp, $disc_prof)=mysql_fetch_array($res_prof);

$prof_demandeur=$civ." ".$pren." ".$nomp ;
if ($MODULE=='Melia') $disc_dem=$disc_prof; else $disc_dem=-1;
//print "total coches élèves : ".$total_coche_eleve."Total coches items : ".$total_coche_item."<br>";

for ($varitem=0;$varitem<$total_coche_item;$varitem++)      {
  for ($vareleve=0;$vareleve<$total_coche_eleve;$vareleve++)     {

  if (isset($coche_eleve[$vareleve])) $id_eleve=$coche_eleve[$vareleve];
        else unset($id_eleve);
  if (isset($coche_item[$varitem])) $id_item=$coche_item[$varitem];
        else unset($id_item);
  $message="";
  if (isset($id_eleve) && isset($id_item)) { //seuls cas à traiter

    // verif et mise à jour de demandes
    $resdemande=query("SELECT message_id ".
                      "FROM demandes ".
                      "WHERE (item_id=$id_item) AND (eleve_id=$id_eleve) ".
                      "AND (TO_DAYS(CURDATE())-TO_DAYS(demandes.quand))<".$etab_nbj_vie_demande."
                       AND disc_id=$disc_dem");

     $rowdemande=mysql_fetch_array($resdemande);

    //Boucle extérieure si l'item est acquis on ne fait rien
    if (itemacquis($id_eleve,$id_item,$disc_dem)) {
       $message="Item déjà acquis précédemment";

       } else { //item non acquis on va voir si la demande existe et n'est pas obsolète
       if ($rowdemande)
         $message_id=$rowdemande["message_id"];
       else {      //Création de demande si elle n'existe pas

       //ATTENTION à la discipline préparée plus haut

         $sql="INSERT INTO demandes( quand, commentaire, eleve_id, item_id, disc_id)".
                "VALUES(NOW(),'Demande du prof : $prof_demandeur ', '$id_eleve', '$id_item','$disc_dem');";
         $res=query($sql);
         // recuperation de l'identifiant
         $message_id=@mysql_insert_id();
         }
       // mise à jour de reponses si le bilan n'est pas true
       //Attention, vérifier si le prof n'a pas déjà donné son avis positif !
       $avisprof=reponse_prof($prof_id,$message_id);
       if ($avisprof) $message="Validation déjà donnée par ce professeur";

       if ((!bilan($id_eleve,$id_item,$disc_dem)) and (!$avisprof)) { //le disc_id du prof (normal pour Melia)
          $sql="INSERT INTO reponses
                 SET accord=1, quand=NOW(),
                     commentaire='".addslashes($commentaire)."',
                     message_id=$message_id, prof_id=$prof_id";
                $res=query($sql);
                }
       // mise à jour de resultat si le bilan des demandes-réponses est true
       //ATTENTION à $disc_id qui est la discipline du prof
       //bilan() le gère bien pour GiBii,
       //Mais il ne faut pas l'enregistrer pour l'élève

       if (bilan($id_eleve,$id_item,$disc_dem)) {
            $sql="INSERT INTO resultats
                     SET eleve_id=$id_eleve,
                          item_id=$id_item, disc_id=$disc_dem,
                             quand=NOW()";
            query($sql);
            calcule_brevets($id_eleve);
            $message="item acquis";
            }

    } //Fin de traitement

     print "<font size='-2' >l'item $id_item à l'élève ".geteleve($id_eleve)."\t le $aujourdhui ";
     print "<font color='red'>".$message."</font></font><br>";
     } // fin du if  cas à traiter

   } // 2° for

} // 1° for


echo "<center>demande traitée<form method='post' action='../prof/prof_bas.php'>
<input type='submit' class='coul' name='retour' value='Retour'>
</form>
</body>";