<?php



superflush(); //pour afficher le alert immédiatement
//___________________________________________________________________

//mise à jour de 3.5 à 4.0 vers 4.1
//___________________________________________________________________

$resversion=query("SELECT param_val FROM _params_globaux WHERE param_nom='VERSION_GIBII'");
if (!list($version)=mysql_fetch_array($resversion)) {
   //anormal ; une erreur sera signalée plus loin
   print ('<br>Il apparaît que votre version de GiBii ne permet pas cette mise à jour<br>');
   return; //on est dans un include donc on revient au prog principal
   }
$ver=vbase100($version);
if ($ver<30500) {
   print ('<br>La mise à jour de GiBii suppose au moins une version 3.5 au départ<br>');
   return;
   }
if ($ver<=40000) {
    if ($ver==30500) { //(Obligatoirement GiBii et pas Melia !)
        query("INSERT INTO _params_globaux (param_nom,param_type,param_val,param_desc,param_tag)
              VALUES ('MODULE', 's', 'GiBii', 'Module GiBii', '-1')");

        query("ALTER TABLE demandes ADD disc_id INT DEFAULT '-1' NOT NULL") ;
        query("ALTER TABLE resultats ADD disc_id INT DEFAULT '-1' NOT NULL") ;
        query("CREATE TABLE lien_eleves_disciplines (
                     rang tinyint(4) default NULL,
                     eleve_id int(11) NOT NULL default '0',
                     disc_id int(11) NOT NULL default '0'
                     ) TYPE=MyISAM");
        query("ALTER TABLE disciplines ADD code_langue CHAR(2) DEFAULT ''");
        query("ALTER TABLE eleves ADD lastdisc TINYINT DEFAULT '-1' AFTER annee") ;

        //correctifs apparus entre 3.5 et 4.0
        query("ALTER TABLE etablissements CHANGE niveau niveau ENUM('niv1','niv2','niv3','niv12','niv23','niv123') DEFAULT 'niv1' NOT NULL ");
        if (!champ_dans_table('alert_message_vide','etablissements',$db))
            query("ALTER TABLE etablissements ADD alert_message_vide TINYINT DEFAULT '0' NOT NULL ;");

        }
    //ici, on est obligatoirement en 3.5 ou 4.0 bêta1
    //===============================================
    //modifs de structure (date et comment sont des mots réservés de MySQL 4.x)
    //-------------------------------------------------------------------------
    @mysql_query("ALTER TABLE demandes
                       CHANGE date quand DATETIME DEFAULT '0000-00-00 00:00:00' NOT NULL,
                       CHANGE comment commentaire TEXT DEFAULT NULL");
    @mysql_query("ALTER TABLE reponses
                       CHANGE date quand DATETIME DEFAULT NULL ,
                       CHANGE comment commentaire TEXT DEFAULT NULL");
    @mysql_query("ALTER TABLE resultats
                       CHANGE date quand DATETIME DEFAULT '0000-00-00 00:00:00' NOT NULL");
    }
//on est au moins en 4.1


//préalable... changements des valeurs par défaut du tag
query("UPDATE profs  SET tag=0 WHERE tag IS NULL");
query("UPDATE eleves SET tag=0 WHERE tag IS NULL");


//___________________________________________________________________

//01_simplitem
//___________________________________________________________________

if (!isset($SIMPLITEM))
 query("INSERT INTO _params_globaux VALUES ('SIMPLITEM', 'i', '1', 'L\'admin ne peut pas accéder à la simplification des items', 0);");

//___________________________________________________________________

//01_disc_gibii.php
//___________________________________________________________________

//certaines tables demandes ont leur disc_id =0 voire NULL !
//
if (($MODULE=='GiBii') or ($MODULE=='GiCii')) {
  query("UPDATE demandes SET disc_id=-1");
  query("UPDATE resultats SET disc_id=-1");
}


//___________________________________________________________________

//02_les groupes vers 4.3
//___________________________________________________________________

if (table_dans_base('lien_eleves_classes',$db)) {
    //chercher les élèves dont la classe n'est pas recensée dans lien_eleves_classes
    //Pour les cas trouvés, enregistrer le résultat dans la table liens
    $res=query("SELECT eleves.eleve_id,eleves.classe_id
                  FROM eleves
             LEFT JOIN lien_eleves_classes
                    ON eleves.eleve_id=lien_eleves_classes.eleve_id
                 WHERE lien_eleves_classes.classe_id IS NULL
                   AND eleves.annee=".ascol());
    while (list($eleve_id,$classe_id)=mysql_fetch_array($res)) {
        query("INSERT INTO lien_eleves_classes SET eleve_id=$eleve_id, classe_id=$classe_id");
        }
    }
else {
    query("CREATE TABLE lien_eleves_classes (
            eleve_id INTEGER NOT NULL,
            classe_id INTEGER NOT NULL,
            KEY IDX_lien_eleves_classes1(eleve_id) )");
    query("INSERT INTO lien_eleves_classes (eleve_id,classe_id)
            SELECT eleve_id,classe_id FROM eleves");
}


//___________________________________________________________________

//04_login 22
//___________________________________________________________________

query("ALTER TABLE `comptes` CHANGE `login` `login` VARCHAR( 22 ) DEFAULT NULL");

//___________________________________________________________________

//06_vouvoiement
//___________________________________________________________________

if (!champ_dans_table('vouvoyer_elev','etablissements',$db))
	query("ALTER TABLE `etablissements` ADD `vouvoyer_elev` TINYINT DEFAULT '0' NOT NULL AFTER `pop_profs");

//___________________________________________________________________

//07_index led : PRIMARY non désiré
//___________________________________________________________________

$res=mysql_query("SHOW INDEX FROM lien_eleves_disciplines");
$existe=false;
while($row=mysql_fetch_array($res)) {
    if ($row['Key_name']=='PRIMARY')  {
        $existe=true;
        break;
        }
    }
if ($existe) {
    query("ALTER TABLE lien_eleves_disciplines DROP PRIMARY KEY");
    }




?>