<?php
#=
/****************************************************************************
Copyright 2002, Daniel Deycard, Jacques Messines, Stéphanie Roussel, Jean-Marie Treins
(CATICE Académie de Bordeaux)

This file is part of GiBii/Melia.

GiBii/Melia is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

GiBii/Melia is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GiBii/Melia; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

****************************************************************************/

include("../include/vars_adm.php");
include("../include/util.inc.php");
include("../sadmin/backup.inc.php");

opensession('Sadmin',false);
$modele_cs='# checksum=';

function mon_hook($sql_insert) {
    global $tmp_buffer;
    $tmp_buffer .= $sql_insert . ';' . $GLOBALS['crlf'];
}

///////////////////////
//Programme principal//
///////////////////////

connecte($host,$user,$mdp,$db);


$crlf        = bon_crlf();
$filename    = 'TOUT_'.$db.'_'.date("Y_m_j");

$restables  = mysql_list_tables($db);
$num_tables = @mysql_numrows($restables);
for ($i=0; $i<$num_tables; $i++)
    $tables[$i]=mysql_tablename($restables, $i);

if ($zip!="non") {
    $ext=$zip;
    $filename.='.sql';
}
else $ext="sql";

// Envoi des en-têtes

prepare_download($filename.'.'.$ext);


$dump_buffer        = '';
$dump_buffer       .= "# Backup complet pour $MODULE version $VERSION_GIBII.". $crlf
                   .  '# CATICE ' . $crlf
                   .  '# DD-JM, décembre 2001 - janvier 2007'. $crlf
                   .  '#' . $crlf;
$dump_buffer       .= $crlf
                   .  '# Créé le       : ' . date('F j, Y, g:i a') . $crlf
                   .  '# Version PHP   : ' . phpversion() . $crlf
                   .  '# Base          : ' . $db . $crlf;

for ($i=0; $i<$num_tables; $i++) {
    $table = $tables[$i];
    if (is_table_temp($table)) continue;
    $dump_buffer.= $crlf.'# ------------------------------'
                .  $crlf . '#' . $crlf
                .  '# Structure de la table '. $table . $crlf
                .  '#' . $crlf . $crlf
                .  get_table_def($db, $table, $crlf) . $crlf;
    $dump_buffer .= $crlf . '#' . $crlf
                 .  '# Contenu de la table '. $table . $crlf
                 .  '#' . $crlf .$crlf;
    $tmp_buffer  = '';
    get_table_content($db, $table, '','mon_hook');
    $dump_buffer .= $tmp_buffer;
} // while

$dump_buffer .= $crlf;
$dump_buffer .=$modele_cs.crc32($dump_buffer);

if ($zip == 'bz2') {
    if (@function_exists('bzcompress')) {
        print bzcompress($dump_buffer);
    }
}
else if ($zip == 'gz') {
    if (@function_exists('gzencode')) {
        print gzencode($dump_buffer);
    }
}

else {
    print $dump_buffer;
    }
/*

$azip=new zipfile();
$xml=file($nomfictxt);
$contenutxt='';
foreach($txt as $ligne) $contenutxt.=$ligne;
$azip->addFile($contenutxt, "$basefic/$basefic.txt");
$contenuzip=$azip->file();
$h=fopen($nomficzip,"w");
fputs($h,$contenuzip);
fclose($h);
*/

?>